﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;
using HDLVisualizerDefinitions;


namespace GraphicalObjects
{
    public class PositionGenerator
    {
        List<List<String>> universalList = null;
        List<List<string>> matrix = null;
        int maxhight, medzera, horizontalimit, verticallimit;
        int nadradenyindex = -1;
        List<Signals> localSignalList = null;
        List<int> verticalPoint = null;
        

        public void SetModulesPosition(ref List<Modules> list, ref Modules parentmodule)
        {
            List<List<String>> verticalList = new List<List<string>>();
            List<String> conflictList = new List<string>();
            List<int> conflictCount = new List<int>();
            List<char> moduleComp = new List<char>();
            List<char> moduleCompBest = null;
            List<char> moduleCompActual = null;
            List<String> verticalMap = new List<string>();
            List<List<String>> moduleList = new List<List<string>>();
            List<int> visitedSignal = new List<int>();
            List<List<string>> matrix_tmp = null;
            List<List<String>> moduleListUnique = new List<List<string>>();
            List<int> moduleListUniqueCount = new List<int>();
            List<List<String>> moduleList_tmp = null;
            int i, j, k, rovnasa, najkonflikt, najkonfliktpos, maxcount, bodka1, bodka2, listindex, stlpec, riadok, modul;
            bool isVisitedSignal;

            universalList = new List<List<string>>();
            nadradenyindex = -1;
            localSignalList = new List<Signals>();

            if ((horizontalimit == 1) || (verticallimit == 1))
            {
                horizontalimit = 0;
                verticallimit = 0;
            }
            
            //vypocitame rozmery mriezky. pripadne pouzijeme hodnoty horizontallimit alebo verticallimit z nastavenia
            if ((horizontalimit == 0) && (verticallimit == 0))  //vytvorime stvorcovy, resp. obdlznikovy tvar matice
            {
                maxcount = 0;
                maxcount = Convert.ToInt32(Math.Sqrt(Convert.ToDouble(list.Count)));    //automaticke zistenie rozmerov mriezky
                horizontalimit = maxcount;
                if ((horizontalimit * horizontalimit) < list.Count)
                {
                    verticallimit = horizontalimit + 1;
                }
                else
                {
                    verticallimit = horizontalimit;
                }
            }
            else if (horizontalimit > 1) //minimalne 2 stlpce
            {
                maxcount = list.Count / horizontalimit;
                if ((maxcount * horizontalimit) < list.Count)
                    maxcount++;
                verticallimit = maxcount;
            }
            else if (verticallimit > 1) //minimalne 2 riadky
            {
                maxcount = list.Count / verticallimit;
                if ((maxcount * verticallimit) < list.Count)
                    maxcount++;
                horizontalimit = maxcount;
            }

            //vytvorenie zoznamu signalov, ktore sa vyskutuju na danej urovni
            foreach (Modules module in list)
            {
                foreach (Ports port in module.GetPortList())
                {
                    if (port.GetSignalList(true, module.GetPath()) != null)
                        foreach (Signals item in port.GetSignalList(true, module.GetPath()))
                        {
                            if (!(localSignalList.Contains(item)))
                            {
                                localSignalList.Add(item);
                            }
                        }
                    if (port.GetRotate() == 0)   //nahranie rotate hodnoty
                    {
                        if (port.GetOrientation().ToUpper().Equals("IN"))
                        {
                            port.SetRotate(Direction.Left);
                        }
                        else if ((port.GetOrientation().ToUpper().Equals("OUT")) || (port.GetOrientation().ToUpper().Equals("INOUT")))
                        {
                            port.SetRotate(Direction.Right);
                        }
                    }
                }
            }



            //vytvorenie dvojic modulov, ktore su prepojene signalom
            foreach (Modules module in list)
            {
                foreach (Ports port in module.GetPortList())
                {
                    if (port.GetSignalList(true, module.GetPath()) == null) //port daneho modulu nema ziadne signaly pre zobrazovanu uroven
                        continue;

                    foreach (Signals item in port.GetSignalList(true, module.GetPath()))
                    {
                        isVisitedSignal = false;
                        foreach (int polozka in visitedSignal)
                        {
                            if (polozka == (localSignalList.IndexOf(item))) //osetrenie, aby sa kazdy signal prezrel iba raz
                                isVisitedSignal = true;
                        }

                        if (!isVisitedSignal)   //signal sa prezera prvy krat
                        {
                            //int referencnybod = -1;
                            for (i = 0; i < item.GetPortCount(); i++)
                            {
                                for (j = 0; j < item.GetPortCount(); j++)
                                {
                                    if (i != j)
                                    {
                                        //zistime pocet bodiek v modulePath kazdeho portu, ktory tvori signal; pocet bodiek == hierarchicka uroven 
                                        bodka1 = 0;
                                        foreach (char znak in item.GetPort(i).GetModule().GetPath())
                                        {
                                            if (znak == '.')
                                                bodka1++;
                                        }
                                        bodka2 = 0;
                                        foreach (char znak in item.GetPort(j).GetModule().GetPath())
                                        {
                                            if (znak == '.')
                                                bodka2++;
                                        }
                                        String iportOrientation = null;
                                        String jportOrientation = null;
                                        /*
                                         * Osetrenie pre INOUT porty - skontrolujeme akeho typu su ostatne porty v signale, a podla toho urcime, ci port sa sprava ako IN alebo ako OUT
                                         * */
                                        if (item.GetPort(i).GetOrientation().ToUpper().Equals("INOUT"))
                                        {
                                            int inPortCount = 0;
                                            int outPortCount = 0;
                                            foreach (Ports port2 in item.GetPortList())
                                            {
                                                if (port2.GetOrientation().ToUpper().Equals("IN"))
                                                    inPortCount++;
                                                else if (port2.GetOrientation().ToUpper().Equals("OUT"))
                                                    outPortCount++;
                                            }
                                            if ((inPortCount == 0) && (outPortCount > 0))
                                                iportOrientation = "IN";
                                            else if ((inPortCount > 0) && (outPortCount == 0))
                                                iportOrientation = "OUT";
                                            else if ((inPortCount == 1) && (outPortCount > 1))
                                                iportOrientation = "OUT";
                                            else if ((inPortCount > 1) && (outPortCount == 1))
                                                iportOrientation = "IN";
                                            else
                                                iportOrientation = "OUT";   //nie je mozne rozhodnut,ci pre dany signal sa sprava inout port ako in alebo ako out
                                        }
                                        else
                                        {
                                            iportOrientation = item.GetPort(i).GetOrientation().ToUpper();
                                        }

                                        if (item.GetPort(j).GetOrientation().ToUpper().Equals("INOUT"))
                                        {
                                            int inPortCount = 0;
                                            int outPortCount = 0;
                                            foreach (Ports port2 in item.GetPortList())
                                            {
                                                if (port2.GetOrientation().ToUpper().Equals("IN"))
                                                    inPortCount++;
                                                else if (port2.GetOrientation().ToUpper().Equals("OUT"))
                                                    outPortCount++;
                                            }
                                            if ((inPortCount == 0) && (outPortCount > 0))
                                                jportOrientation = "IN";
                                            else if ((inPortCount > 0) && (outPortCount == 0))
                                                jportOrientation = "OUT";
                                            else if ((inPortCount == 1) && (outPortCount > 1))
                                                jportOrientation = "OUT";
                                            else if ((inPortCount > 1) && (outPortCount == 1))
                                                jportOrientation = "IN";
                                            else
                                                jportOrientation = "OUT";   //nie je mozne rozhodnut,ci pre dany signal sa sprava inout port ako in alebo ako out
                                        }
                                        else
                                        {
                                            jportOrientation = item.GetPort(j).GetOrientation().ToUpper();
                                        }

                                        //ulozime dvojice prepojeni, z OUT portu do IN portu (vsetky dvojice prepojeni v signale)
                                        //A$module a B$module su imaginarne moduly, ktore predstavuju jeden, hierarchicky nadradeny modul
                                        if ((bodka1 == bodka2) && (iportOrientation.Equals("OUT") && jportOrientation.Equals("IN")))  //prepoj dvoch modulov na rovnakej urovni
                                        {
                                            moduleList.Add(new List<string>());
                                            moduleList[moduleList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                            moduleList[moduleList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                            universalList.Add(new List<string>());
                                            universalList[universalList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                            universalList[universalList.Count - 1].Add(item.GetPort(i).GetName());
                                            universalList[universalList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                            universalList[universalList.Count - 1].Add(item.GetPort(j).GetName());
                                            universalList[universalList.Count - 1].Add(localSignalList.IndexOf(item).ToString());
                                            universalList[universalList.Count - 1].Add("false");
                                            verticalList.Add(new List<string>());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetName());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetName());

                                        }
                                        else if ((bodka1 < bodka2) && (iportOrientation.Equals("IN") && jportOrientation.Equals("IN"))) //prepoj modulov z vyssej urovne na nizsiu
                                        {
                                            moduleList.Add(new List<string>());
                                            moduleList[moduleList.Count - 1].Add("A$module");
                                            moduleList[moduleList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                            universalList.Add(new List<string>());
                                            universalList[universalList.Count - 1].Add("A$module");
                                            universalList[universalList.Count - 1].Add(item.GetPort(i).GetName());
                                            universalList[universalList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                            universalList[universalList.Count - 1].Add(item.GetPort(j).GetName());
                                            universalList[universalList.Count - 1].Add(localSignalList.IndexOf(item).ToString());
                                            universalList[universalList.Count - 1].Add("false");
                                            verticalList.Add(new List<string>());
                                            verticalList[verticalList.Count - 1].Add("A$module");
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetName());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetName());
                                        }
                                        else if ((bodka1 > bodka2) && (iportOrientation.Equals("OUT") && jportOrientation.Equals("OUT"))) //prepoj modulov z nizsej urovne na vyssiu
                                        {
                                            moduleList.Add(new List<string>());
                                            moduleList[moduleList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                            moduleList[moduleList.Count - 1].Add("B$module");
                                            universalList.Add(new List<string>());
                                            universalList[universalList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                            universalList[universalList.Count - 1].Add(item.GetPort(i).GetName());
                                            universalList[universalList.Count - 1].Add("B$module");
                                            universalList[universalList.Count - 1].Add(item.GetPort(j).GetName());
                                            universalList[universalList.Count - 1].Add(localSignalList.IndexOf(item).ToString());
                                            universalList[universalList.Count - 1].Add("false");
                                            verticalList.Add(new List<string>());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetName());
                                            verticalList[verticalList.Count - 1].Add("B$module");
                                            verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetName());
                                        }
                                        //else if ((bodka1 == bodka2) && (iportOrientation.Equals("IN") && jportOrientation.Equals("IN")) && (item.GetIsClock())) //prepoj portov hodinovym signalom
                                        //{
                                        //    if (referencnybod == -1)
                                        //        referencnybod = item.GetPortList().IndexOf(item.GetPort(i));
                                        //    if (item.GetPortList().IndexOf(item.GetPort(i)) == referencnybod)
                                        //    {
                                        //        moduleList.Add(new List<string>());
                                        //        moduleList[moduleList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                        //        moduleList[moduleList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                        //        universalList.Add(new List<string>());
                                        //        universalList[universalList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                        //        universalList[universalList.Count - 1].Add(item.GetPort(i).GetName());
                                        //        universalList[universalList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                        //        universalList[universalList.Count - 1].Add(item.GetPort(j).GetName());
                                        //        universalList[universalList.Count - 1].Add(localSignalList.IndexOf(item).ToString());
                                        //        universalList[universalList.Count - 1].Add("true");
                                        //        verticalList.Add(new List<string>());
                                        //        verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetModule().GetName());
                                        //        verticalList[verticalList.Count - 1].Add(item.GetPort(i).GetName());
                                        //        verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetModule().GetName());
                                        //        verticalList[verticalList.Count - 1].Add(item.GetPort(j).GetName());
                                        //    }
                                        //}
                                    }
                                }
                            }
                            visitedSignal.Add(localSignalList.IndexOf(item));  //pridame aktualny signal k zoznamu prezretych signalov
                        }
                    }
                }
            }
            if (universalList.Count != 0)
            {
                
                //vypocitame velkost medzery medzi modulmi - minimum 50
                medzera = 50;
                if (universalList.Count > (2 * list.Count))
                    medzera = medzera + ((universalList.Count / list.Count) * 30);
                //ak chyba parent module, vytvorime ho 
                if (parentmodule == null)
                {
                    parentmodule = new Modules("imaginare$module");
                }
                //moduleList obsahuje zoznam dvojic modulov, ktore su navzajom prepojene signalmi, v tvare: modul1, modul2
                //vytvorime pomocny zoznam dvojic modulov z moduleList, ale bez duplicity
                foreach (List<String> polozka in moduleList)
                {
                    if (!(IsInList(moduleListUnique, polozka)))
                    {
                        moduleListUnique.Add(new List<string>());
                        moduleListUnique[moduleListUnique.Count - 1].Add(polozka[0]);
                        moduleListUnique[moduleListUnique.Count - 1].Add(polozka[1]);
                        moduleListUniqueCount.Add(1);   //pocet vyskytov danej dvojice, na zaciatku 1x
                    }
                    else
                    {
                        moduleListUniqueCount[IndexInList(moduleListUnique, polozka)]++;
                    }
                }

                /* vymazanie opacnych dvojic prepojenych modulov zo zoznamu
                 * Ak modul1->modul2,vyskyt 2x a  modul2->modul1,vysky2x ==> su opacne, rovnaky pocet vyskytov - vymazeme ich
                 * Ak modul1->modul2,vyskyt 2x a  modul2->modul1,vysky1x ==> su opacne, rozdielny pocet vyskytov - ostane modul1->modul2,vyskyt 1x
                 * */
                for (i = 0; i < moduleListUnique.Count; i++)
                {
                    for (j = 0; j < moduleListUnique.Count; j++)
                    {
                        String nodeleft1, noderight1, nodeleft2, noderight2;
                        nodeleft1 = ParseList(moduleListUnique[i], 0);
                        noderight1 = ParseList(moduleListUnique[i], 1);
                        nodeleft2 = ParseList(moduleListUnique[j], 0);
                        noderight2 = ParseList(moduleListUnique[j], 1);

                        if ((nodeleft2.Equals(noderight1)) && (noderight2.Equals(nodeleft1))) //su opacne
                        {
                            if (moduleListUniqueCount[i] > moduleListUniqueCount[j])
                            {
                                while (moduleListUniqueCount[j] != 0)
                                {
                                    moduleList = ModuleListRemove(moduleList, nodeleft2, noderight2);
                                    moduleListUniqueCount[j]--;
                                }
                                while (moduleListUniqueCount[i] != 1)
                                {
                                    moduleList = ModuleListRemove(moduleList, nodeleft1, noderight1);
                                    moduleListUniqueCount[i]--;
                                }
                            }
                            else if (moduleListUniqueCount[j] > moduleListUniqueCount[i])
                            {
                                while (moduleListUniqueCount[i] != 0)
                                {
                                    moduleList = ModuleListRemove(moduleList, nodeleft1, noderight1);
                                    moduleListUniqueCount[i]--;
                                }
                                while (moduleListUniqueCount[j] != 1)
                                {
                                    moduleList = ModuleListRemove(moduleList, nodeleft2, noderight2);
                                    moduleListUniqueCount[j]--;
                                }
                            }
                            else if (moduleListUniqueCount[j] == moduleListUniqueCount[i])
                            {
                                while (moduleListUniqueCount[i] != 1)
                                {
                                    moduleList = ModuleListRemove(moduleList, nodeleft1, noderight1);
                                    moduleList = ModuleListRemove(moduleList, nodeleft2, noderight2);
                                    moduleListUniqueCount[i]--;
                                }
                            }
                        }
                    }
                }

                //opat vymazeme duplicity - aby sme mali kazdy prepoj iba raz
                moduleListUnique = moduleList;
                moduleList = null;
                moduleList = new List<List<string>>();
                foreach (List<String> polozka in moduleListUnique)
                {
                    if (!(IsInList(moduleList, polozka)))
                    {
                        moduleList.Add(new List<string>());
                        moduleList[moduleList.Count - 1].Add(polozka[0]);
                        moduleList[moduleList.Count - 1].Add(polozka[1]);
                    }
                }

                //vytvorime kopiu moduleListu
                moduleList_tmp = new List<List<string>>();
                moduleList_tmp = CopyList(moduleList);

                //vytvorime 2-rozmernu mriezku, do ktorej budeme ukladat moduly tak, ako budu rozmiestnene
                matrix = new List<List<string>>();

                //do 1.stlpca vlozime Amodule, co predstavuje vstupne porty nadradeneho modulu
                matrix.Add(new List<string>());
                matrix[0].Add("A$module");
                for (i = 0; i < verticallimit - 1; i++)
                    matrix[0].Add("");

                //vytvorime prazdnu mriezku 
                for (i = 0; i < horizontalimit; i++)
                {
                    matrix.Add(new List<string>());
                    for (j = 0; j < verticallimit; j++)
                    {
                        matrix[i + 1].Add("");
                    }
                }
                //do posledneho stlpca vlozime Bmodule, co predstavuje vystupne porty nadradeneho modulu
                matrix.Add(new List<string>());
                matrix[matrix.Count - 1].Add("B$module");
                for (i = 0; i < verticallimit - 1; i++)
                    matrix[matrix.Count - 1].Add("");

                //matrix je pripraveny na ukladanie modulov podla stlpcov

                List<String> Alock = new List<string>();
                List<String> Block = new List<string>();
                List<String> NOlock = new List<string>();
                //ulozime dvojice zacinajuce z Amodule a vytvorime Alock
                for (k = 0; k < moduleList.Count; )
                {
                    String nodeleft, noderight;
                    nodeleft = ParseList(moduleList[k], 0);
                    noderight = ParseList(moduleList[k], 1);
                    if (nodeleft == "A$module")
                    {
                        for (i = 1; i <= horizontalimit; i++)
                        {
                            for (j = 0; j < verticallimit; j++)
                            {
                                if (matrix[i][j] == "")
                                {
                                    matrix[i][j] = noderight;
                                    i = horizontalimit + 1;
                                    break;
                                }
                            }
                        }
                        Alock.Add(noderight);
                        moduleList.RemoveAt(k);
                    }
                    else
                    {
                        k++;
                    }

                }
                //ulozime dvojice konciace do Bmodule a vytvorime Block
                for (k = 0; k < moduleList.Count; )
                {
                    String nodeleft, noderight;
                    nodeleft = ParseList(moduleList[k], 0);
                    noderight = ParseList(moduleList[k], 1);
                    if (noderight == "B$module")
                    {
                        if (!(Alock.Contains(nodeleft)))
                        {
                            for (i = horizontalimit; i > 0; i--)
                            {
                                for (j = 0; j < verticallimit; j++)
                                {
                                    if (matrix[i][j] == "")
                                    {
                                        matrix[i][j] = nodeleft;
                                        i = 0;
                                        break;
                                    }
                                }
                            }
                        }
                        Block.Add(nodeleft);
                        moduleList.RemoveAt(k);
                    }
                    else
                    {
                        k++;
                    }
                }
                //do NOlock pridame take moduly, ktore sa nachadzaju v Alock a zaroven v Block
                for (i = 0; i < Alock.Count; )
                {
                    if (Block.Contains(Alock[i]))
                    {
                        Block.Remove(Alock[i]);
                        NOlock.Add(Alock[i]);
                        Alock.RemoveAt(i);
                    }
                    else
                    {
                        i++;
                    }
                }

                //vsetky ostatne polozky zoznamu vlozime do NOlock - tieto polozky sa bud[ medzi sebou moct vymienat
                while (moduleList.Count > 0)
                {
                    String nodeleft, noderight;
                    nodeleft = ParseList(moduleList[0], 0);
                    noderight = ParseList(moduleList[0], 1);
                    int leftpos = 0;
                    int rightpos = 0;
                    foreach (List<String> item in matrix)
                    {
                        if (item.Contains(nodeleft))
                            leftpos = matrix.IndexOf(item);   //stlpec nodeleftu
                        if (item.Contains(noderight))
                            rightpos = matrix.IndexOf(item);   //stlpec noderightu

                    }
                    if ((leftpos != 0) && (rightpos != 0)) //oba moduly su v matrixe
                    {
                        if ((NOlock.Contains(noderight)) && (NOlock.Contains(nodeleft)) && (leftpos > rightpos)) //swap modules
                        {
                            matrix[leftpos].Remove(nodeleft);
                            matrix[leftpos].Add(noderight);
                            matrix[rightpos].Remove(noderight);
                            matrix[rightpos].Add(nodeleft);
                        }
                    }
                    else
                    {
                        if (leftpos == 0) //chyba nodeleft. dame ho na prvu volnu poziciu zlava
                        {
                            for (i = 1; i <= horizontalimit; i++)
                            {
                                for (j = 0; j < verticallimit; j++)
                                {
                                    if (matrix[i][j] == "")
                                    {
                                        matrix[i][j] = nodeleft;
                                        leftpos = i;
                                        i = horizontalimit + 1;
                                        break;
                                    }
                                }
                            }
                            NOlock.Add(nodeleft);
                        }

                        if (rightpos == 0) //chyba noderight. dame ho na prvu volnu poziciu sprava
                        {
                            for (i = horizontalimit; i > 0; i--)
                            {
                                for (j = 0; j < verticallimit; j++)
                                {
                                    if (matrix[i][j] == "")
                                    {
                                        matrix[i][j] = noderight;
                                        rightpos = i;
                                        i = 0;
                                        break;
                                    }
                                }
                            }
                            NOlock.Add(nodeleft);
                        }

                        if ((NOlock.Contains(noderight)) && (NOlock.Contains(nodeleft)) && (leftpos > rightpos)) //swap modules
                        {
                            matrix[leftpos].Remove(nodeleft);
                            matrix[leftpos].Add(noderight);
                            matrix[rightpos].Remove(noderight);
                            matrix[rightpos].Add(nodeleft);
                        }
                    }
                    moduleList.RemoveAt(0);
                }


                //moduly v mriezke su roztriedene do stlpcou

                //docasne - dame tam vsetky moduly, ktore chybaju
                //tot je potrebne prerobit, lebo je problem, ak sa v module liste vynuluju pocty, vtedy by mali ist moduly pod seba

                foreach (Modules module in list)
                {
                    Boolean isInMatrix = false;
                    for (i = 1; i < matrix.Count - 1; i++)
                    {
                        for (j = 0; j < matrix[i].Count; j++)
                        {

                            if (matrix[i][j] == module.GetName())
                            {
                                isInMatrix = true;
                            }
                        }
                    }
                    if (isInMatrix == false)
                    {
                        for (i = 1; i < matrix.Count - 1; i++)
                        {
                            for (j = 0; j < matrix[i].Count; j++)
                            {

                                if (matrix[i][j] == "")
                                {
                                   matrix[i][j] = module.GetName();
                                   isInMatrix = true;
                                   break;
                                }

                            }
                            if (isInMatrix)
                                break;
                        }
                    }
                }
                //je potrebne roztriedit moduly v mriezke aj do riadkov

                k = 0;
                list.Add(parentmodule);    //pridame hierarchicky nadradeny modul do zoznamu modulov, docasne riesenie
                List<List<string>> verticalList_tmp = new List<List<string>>();
                verticalList_tmp = CopyList(verticalList);

                //verticalList obsahuje vsetky prepoje modulov vratane portov v tvare S1,in3>P4;out5
                /*teraz naplnime verticalMap v tvare hh, hd , dh , du ..., kde d=dole, h=hore, u=v strede , Ak dh -> d znamena, ze port in3 modulu S1 je v spodnej polke modulu, a teda je vyhodnejsie 
                 * tahat signal do dola, h znamena, ze port out5 modulu P4 je v hornej polovici a teda je lepsie smerovat signal do hora. V takomto pripade algoritmus ulozi moduly tak, aby S1 bolo vyssie ako P4.                
                 * */
                for (i = 0; i < verticalList.Count; i++)    //nahradime A$module a B$module vo verticalListe nazvom hierarchicky nadradeneho modulu
                {
                    Boolean jetu = false;
                    if (verticalList[i][0] == "A$module")
                        jetu = true;

                    if (jetu)
                    {
                        verticalList[i].RemoveAt(0);
                        verticalList[i].Insert(0, parentmodule.GetName());
                    }
                    jetu = false;
                    if (verticalList[i][2] == "B$module")
                        jetu = true;
                    if (jetu)
                    {
                        verticalList[i].RemoveAt(2);
                        verticalList[i].Insert(2, parentmodule.GetName());
                    }
                }

                //ulozenie verticalMapy v tvare dh, hh, ud, ....
                foreach (List<String> polozka in verticalList)
                {
                    String nodeleft, noderight, nodeleftport, noderightport;
                    Direction smer1, smer2;
                    int counter1, counter2;

                    verticalMap.Add("");
                    nodeleft = ParseList(polozka, 0);
                    nodeleftport = ParseList(polozka, 1);
                    noderight = ParseList(polozka, 2);
                    noderightport = ParseList(polozka, 3);

                    foreach (Modules module in list)
                    {
                        if (nodeleft.Equals(module.GetName()) || noderight.Equals(module.GetName()))
                        {
                            smer1 = Direction.Down;
                            smer2 = smer1;
                            foreach (Ports portik in module.GetPortList())
                            {
                                if (nodeleft.Equals(module.GetName()) && portik.GetName().Equals(nodeleftport))
                                {
                                    if ((parentmodule != null) && (module.GetName() != parentmodule.GetName()))
                                        smer1 = portik.GetRotate();
                                    else
                                    {
                                        if (portik.GetRotate() == Direction.Left)
                                            smer1 = Direction.Right;
                                        else
                                            smer1 = Direction.Left;
                                    }

                                }
                                if (noderight.Equals(module.GetName()) && portik.GetName().Equals(noderightport))
                                {
                                    if ((parentmodule != null) && (module.GetName() != parentmodule.GetName()))
                                        smer2 = portik.GetRotate();
                                    else
                                    {
                                        if (portik.GetRotate() == Direction.Left)
                                            smer2 = Direction.Right;
                                        else
                                            smer2 = Direction.Left;
                                    }

                                }

                            }
                            counter1 = 1;//na zaciatku predpokladame, ze hladany port je na prvej pozicii pre ten svoj smer
                            counter2 = 1;
                            foreach (Ports port in module.GetPortList())
                            {
                                Direction tmpsmer = Direction.Down;
                                if (smer1 == Direction.Right)
                                    tmpsmer = Direction.Left;
                                else
                                    tmpsmer = Direction.Right;
                                if (((parentmodule != null) && (module.GetName() != parentmodule.GetName()) && (port.GetRotate().Equals(smer1))) || ((parentmodule != null) && (module.GetName() == parentmodule.GetName()) && (port.GetRotate().Equals(tmpsmer))))
                                {
                                    if (port.GetName().Equals(nodeleftport))
                                    {
                                        if (module.GetName() == parentmodule.GetName())
                                            i = module.GetPortCountPerDirection(tmpsmer);
                                        else
                                            i = module.GetPortCountPerDirection(port.GetRotate());
                                        if ((i % 2) == 1) //mame neparny pocet
                                        {
                                            if (i == 1)
                                            {
                                                verticalMap[k] = "u" + verticalMap[k];
                                            }
                                            else if (counter1 <= (i / 2))//predpokladam ze zaokruhluje nadol
                                            {
                                                verticalMap[k] = "h" + verticalMap[k];
                                            }
                                            else if (counter1 >= ((i / 2) + 2))
                                            {
                                                verticalMap[k] = "d" + verticalMap[k];
                                            }
                                            else if (counter1 == ((i / 2) + 1))
                                            {
                                                verticalMap[k] = "u" + verticalMap[k];
                                            }
                                        }
                                        else//parny pocet, to znamena 2,4,6,...
                                        {
                                            if (counter1 <= (i / 2))
                                            {
                                                verticalMap[k] = "h" + verticalMap[k];
                                            }
                                            else
                                            {
                                                verticalMap[k] = "d" + verticalMap[k];
                                            }
                                        }
                                    }


                                    counter1++;

                                }
                                tmpsmer = Direction.Down;
                                if (smer2 == Direction.Right)
                                    tmpsmer = Direction.Left;
                                else
                                    tmpsmer = Direction.Right;
                                if (((parentmodule != null) && (module.GetName() != parentmodule.GetName()) && (port.GetRotate().Equals(smer2))) || ((parentmodule != null) && (module.GetName() == parentmodule.GetName()) && (port.GetRotate().Equals(tmpsmer))))
                                {
                                    if (port.GetName().Equals(noderightport))
                                    {
                                        if (module.GetName() == parentmodule.GetName())
                                            i = module.GetPortCountPerDirection(tmpsmer);
                                        else
                                            i = module.GetPortCountPerDirection(port.GetRotate());
                                        if ((i % 2) == 1) //mame neparny pocet
                                        {
                                            if (i == 1)
                                            {
                                                verticalMap[k] = verticalMap[k] + "u";
                                            }
                                            else if (counter2 <= (i / 2))//predpokladam ze zaokruhluje nadol
                                            {
                                                verticalMap[k] = verticalMap[k] + "h";
                                            }
                                            else if (counter2 >= ((i / 2) + 2))
                                            {
                                                verticalMap[k] = verticalMap[k] + "d";
                                            }
                                            else if (counter2 == ((i / 2) + 1))
                                            {
                                                verticalMap[k] = verticalMap[k] + "u";
                                            }
                                        }
                                        else//parny pocet, to znamena 2,4,6,...
                                        {
                                            if (counter2 <= (i / 2))
                                            {
                                                verticalMap[k] = verticalMap[k] + "h";
                                            }
                                            else
                                            {
                                                verticalMap[k] = verticalMap[k] + "d";
                                            }
                                        }
                                    }


                                    counter2++;

                                }

                            }
                        }
                    }
                    k++;
                }

                //obnovenie verticalListu
                verticalList = ClearList(verticalList);
                verticalList = CopyList(verticalList_tmp);

                //teraz mame verticalzoznam aj verticalmapu naplnenu a mozeme porovnat ako su mapovane porty
                rovnasa = 0;
                foreach (Modules module in list)
                {
                    if (module.GetName() != parentmodule.GetName())
                    {
                        conflictList.Add(module.GetName());
                        conflictCount.Add(0);
                    }
                }
                conflictList.Add("A$module");
                conflictList.Add("B$module");
                conflictCount.Add(0);
                conflictCount.Add(0);

                while (conflictList.Count > 0)
                {
                    moduleComp = null;
                    moduleComp = new List<char>();
                    for (k = 0; k < verticalList.Count; k++)
                    {
                        String nodeleft, noderight;
                        i = 0;
                        j = 0;

                        nodeleft = ParseList(verticalList[k], 0);
                        noderight = ParseList(verticalList[k], 2);

                        for (int indexa = 0; indexa < matrix.Count; indexa++)
                            for (int indexb = 0; indexb < matrix[indexa].Count; indexb++)
                            {
                                if (nodeleft.Equals(matrix[indexa][indexb]))
                                    i = indexb;
                                else if (noderight.Equals(matrix[indexa][indexb]))
                                    j = indexb;
                            }
                        if (Math.Abs(i - j) == 0)
                            moduleComp.Add('=');
                        else if (Math.Abs(i - j) == 1)
                        {
                            if ((i > j) && (verticalMap[k].Substring(0, 1).Equals("d")) && (verticalMap[k].Substring(1, 1).Equals("h"))) //prve je nizsie
                                moduleComp.Add('<');
                            else if ((i < j) && (verticalMap[k].Substring(0, 1).Equals("h")) && (verticalMap[k].Substring(1, 1).Equals("d"))) //prve je vyssie
                                moduleComp.Add('>');
                            else
                                moduleComp.Add('=');

                        }
                        else if (Math.Abs(i - j) > 1)
                        {
                            if (i > j)
                                moduleComp.Add('<');
                            else
                                moduleComp.Add('>');
                        }


                    }
                    //porovnanie mame

                    for (k = 0; k < moduleComp.Count; k++)
                    {
                        if (moduleComp[k].Equals('='))
                            rovnasa++;
                        else
                        {
                            String nodeleft, noderight;

                            nodeleft = ParseList(verticalList[k], 0);
                            noderight = ParseList(verticalList[k], 2);
                            for (int index = 0; index < conflictList.Count; index++)
                            {
                                if (nodeleft.Equals(conflictList[index]))
                                    conflictCount[index]++;

                                if (noderight.Equals(conflictList[index]))
                                    conflictCount[index]++;
                            }
                        }
                    }
                    //konflikty mame
                    //teraz najdeme najviac konfliktny 
                    najkonflikt = 0;
                    najkonfliktpos = 0;
                    for (k = 0; k < conflictCount.Count; k++)
                    {
                        if (conflictCount[k] > najkonflikt)
                        {
                            najkonflikt = conflictCount[k];
                            najkonfliktpos = k;
                        }
                    }
                    //
                    int posiciax = 0;
                    int posiciay = 0;
                    for (i = 0; i < matrix.Count; i++)
                        for (j = 0; j < matrix[i].Count; j++)
                            if (matrix[i][j].Equals(conflictList[najkonfliktpos]))
                            {
                                posiciax = i;
                                posiciay = j;
                            }
                    int pompos = 0;
                    int pomrovnasa = 0;
                    int pomrovnasanaj = 0;
                    int najindex = 0;
                    pomrovnasanaj = rovnasa;
                    for (k = 0; k < (matrix[0].Count - 1); k++)//opakuj kolko je riadkov - 1
                    {
                        pompos = posiciay + k + 1;
                        if (pompos >= matrix[0].Count)
                            pompos = pompos - matrix[0].Count;
                        matrix_tmp = matrix;
                        matrix_tmp[posiciax][posiciay] = matrix_tmp[posiciax][pompos];
                        matrix_tmp[posiciax][pompos] = conflictList[najkonfliktpos];
                        //swapnute
                        //teraz zistime pocet novych rovnasa
                        moduleCompActual = new List<char>();
                        for (int index = 0; index < verticalList.Count; index++)
                        {
                            String nodeleft, noderight;
                            i = 0;
                            j = 0;
                            nodeleft = ParseList(verticalList[index], 0);
                            noderight = ParseList(verticalList[index], 2);

                            for (int indexa = 0; indexa < matrix_tmp.Count; indexa++)
                                for (int indexb = 0; indexb < matrix_tmp[indexa].Count; indexb++)
                                {
                                    if (nodeleft.Equals(matrix_tmp[indexa][indexb]))
                                        i = indexb;
                                    else if (noderight.Equals(matrix_tmp[indexa][indexb]))
                                        j = indexb;
                                }
                            if (Math.Abs(i - j) == 0)
                                moduleCompActual.Add('=');

                            else if (Math.Abs(i - j) == 1)
                            {
                                if ((i > j) && (verticalMap[index].Substring(0, 1).Equals("d")) && (verticalMap[index].Substring(1, 1).Equals("h"))) //prve je nizsie
                                    moduleCompActual.Add('<');
                                else if ((i < j) && (verticalMap[index].Substring(0, 1).Equals("h")) && (verticalMap[index].Substring(1, 1).Equals("d"))) //prve je vyssie
                                    moduleCompActual.Add('>');
                                else
                                    moduleCompActual.Add('=');

                            }
                            else if (Math.Abs(i - j) > 1)
                            {
                                if (i > j)
                                    moduleCompActual.Add('<');
                                else
                                    moduleCompActual.Add('>');
                            }


                        }
                        //mame porovnane
                        for (i = 0; i < moduleCompActual.Count; i++)
                        {
                            if (moduleCompActual[i].Equals('='))
                                pomrovnasa++;
                        }
                        if (pomrovnasa < pomrovnasanaj)
                        {
                            pomrovnasanaj = pomrovnasa;
                            najindex = pompos;
                            moduleCompBest = moduleCompActual;
                        }
                        String matrix_item = matrix_tmp[posiciax][pompos];
                        matrix_tmp[posiciax][pompos] = matrix_tmp[posiciax][posiciay];
                        matrix_tmp[posiciax][posiciay] = matrix_item;

                    }
                    if (pomrovnasanaj < rovnasa)
                    {
                        moduleComp = moduleCompBest;
                        rovnasa = pomrovnasanaj;
                        matrix[posiciax][posiciay] = matrix[posiciax][najindex];
                        matrix[posiciax][najindex] = conflictList[najkonfliktpos];



                    }
                    // else

                    //teraz musime z konfliktov odobrat ten vajvacsi aby sa nam zmensil array
                    conflictList.RemoveAt(najkonfliktpos);
                    conflictCount.RemoveAt(najkonfliktpos);
                    for (i = 0; i < conflictCount.Count; i++)
                        conflictCount[i] = 0;
                }

                //mriezka je dokoncena, vsetky moduly su rozmiestnene optimalne
                //ideme zadelit suradnice
                maxhight = 0;
                listindex = 0;
                while (listindex < list.Count)  //odoberieme zo zoznamu modulov hierarchicky nadradeny - pretoze ten nevykreslujeme
                {
                    if (list[listindex].GetName() == parentmodule.GetName())
                        list.RemoveAt(listindex);
                    else
                        listindex++;
                }

                //foreach (Modules module in list)    //zistime ktory modul ma najviac portov - podla toho urcime vertikalny rozostup medzi modulmi
                //{
                //    if (module.GetPortCountPerDirectionMax() > maxhight)
                //        maxhight = module.GetPortCountPerDirectionMax();
                //}
                //maxhight *= 50;
                //maxhight += 130;

                maxhight = 50;

                int maxportcount = 0;
                verticalPoint = new List<int>();

                modul = 0;
                for (riadok = 0; riadok < matrix[0].Count; riadok++)   //pre kazdy stlpec a riadok mriezky najdeme zodpovedajuci modul a priradime mu poziciu
                {
                    maxportcount = 0;
                    for (stlpec = 0; stlpec < matrix.Count; stlpec++)
                    {
                        for (k = 0; k < list.Count; k++)
                        {
                            if (matrix[stlpec][riadok].Equals(list[k].GetName()))
                            {
                                modul = k;
                                list[modul].SetPosX1(0 + (stlpec * (250 + medzera)));
                                list[modul].SetPosY1(maxhight);
                                list[modul].SetPosX2(list[modul].GetPosX1() + 150);
                                list[modul].SetPosY2((list[modul].GetPosY1() + 50) + (list[modul].GetPortCountPerDirectionMax() * 50));
                                if (list[modul].GetPortCountPerDirectionMax() > maxportcount)
                                    maxportcount = list[modul].GetPortCountPerDirectionMax();
                            }
                        }
                    }
                    verticalPoint.Add(maxhight);
                    maxhight = list[modul].GetPosY1() + 50 + (maxportcount * 50) + medzera;
                }
                verticalPoint.Add(maxhight);
            }
            else
            {
                //v pripade, ze nemame ziadne prepoje, je jedno ako budu moduly rozmiestnene
                i = 0;
                stlpec = 0;
                riadok = 0;
                maxhight = 50;
                medzera = 50;
                int maxportcount = 0;
                while (i < list.Count)
                {
                    maxportcount = 0;
                    while (stlpec < horizontalimit && i < list.Count)
                    {
                        list[i].SetPosX1(100 + (stlpec * (250 + medzera)));
                        list[i].SetPosY1(maxhight);
                        list[i].SetPosX2(list[i].GetPosX1() + 150);
                        list[i].SetPosY2(list[i].GetPosY1() + 50 + (list[i].GetPortCountPerDirectionMax() * 50));
                        if (list[i].GetPortCountPerDirectionMax() > maxportcount)
                            maxportcount = list[i].GetPortCountPerDirectionMax();
                        i++;
                        stlpec++;
                    }
                    riadok++;
                    stlpec = 0;
                    maxhight = list[i - 1].GetPosY1() + 50 + (maxportcount * 50) + medzera;
                }
            }
        }

        public void SetPortsPosition(ref List<Modules> list, ref Modules parentmodule)
        {
            int left = 0;
            int right = 0;
            //Modules nadradeny = null;
            //if (nadradenyindex != -1)
            //{
            //    nadradeny = listmodules[nadradenyindex];
            //}

            foreach (Modules module in list)
            {
                foreach (Ports port in module.GetPortList())
                {
                    if (port.GetRotate() == Direction.Left)
                    {
                        port.SetPosX1(module.GetPosX1());
                        port.SetPosY1((module.GetPosY1() + 0x19) + (left * 50));
                        left++;
                    }
                    if (port.GetRotate() == Direction.Right)
                    {
                        port.SetPosX1(module.GetPosX1() + 200);
                        port.SetPosY1((module.GetPosY1() + 0x19) + (right * 50));
                        right++;
                    }

                }
                left = 0;
                right = 0;
            }

            if (parentmodule != null && matrix != null)
            {
                left = 0;
                right = 0;
                foreach (Ports port in parentmodule.GetPortList())
                {
                    if (port.GetRotate() == Direction.Left)//pozicia matrixu A
                    {
                        for (int riadok = 0; riadok < matrix[0].Count; riadok++)
                        {
                            if (matrix[0][riadok].Equals("A$module"))
                            {
                                port.SetPosX2(200);
                                //port.SetPosY2(50 + verticalPoint[riadok] + (left * 50));  - este prerobit !!!
                                int tmp = matrix[0].Count;
                                tmp = ((verticalPoint[tmp] / 2) - medzera) - ((parentmodule.GetPortCountPerDirection(Direction.Left) / 2) * 50);
                                port.SetPosY2(50 + tmp + (left * 50));
                            }
                        }
                        left++;
                    }
                    if (port.GetRotate() == Direction.Right)//pozicia matrixy B
                    {
                        for (int riadok = 0; riadok < matrix[matrix.Count - 1].Count; riadok++)
                        {
                            if (matrix[matrix.Count - 1][riadok].Equals("B$module"))
                            {
                                port.SetPosX2(0 + ((250 + medzera) * (matrix.Count - 1)));
                                int tmp = matrix[0].Count;
                                tmp = ((verticalPoint[tmp] / 2) - medzera) - ((parentmodule.GetPortCountPerDirection(Direction.Right) / 2) * 50);
                                //port.SetPosY2(50 + verticalPoint[riadok] + (right * 50));
                                port.SetPosY2(50 + tmp + (right * 50));
                            }
                        }
                        right++;
                    }
                }
            }
        }

        public void SetSignalsPositions(ref List<Modules> list, ref Modules parentmodule)
        {
            //if (list.Count != 1)    //ak vykreslujeme iba jeden modul, nevykreslujeme signaly
            if (universalList.Count != 0)
            {
                List<List<List<string>>> path = new List<List<List<string>>>();       //obsahuje vsetky cesty pre kazdu dvojicu prepojenych modulov         
                String a, b, aport, bport;
                int dlzka, dlzka2, cnt, absignal;
                int matrixax, matrixay, matrixbx, matrixby, i, j, index;
                int maxx, maxy;
                int maxMatrixHeight = 0;
                cnt = 0;
                maxx = 0;
                maxy = 0;

                if (parentmodule != null)
                {
                    list.Add(parentmodule);
                    nadradenyindex = list.Count - 1;
                }

                for (i = 0; i < universalList.Count; i++)
                    path.Add(new List<List<string>>());



                foreach (List<string> polozka in matrix)    //zistime kolko riadkov ma najvacsi stlpec mriezky
                {
                    if (polozka.Count > maxMatrixHeight)
                        maxMatrixHeight = polozka.Count;
                }

                /*
                 * naplnenie path - pre kazdu dvojicu prepojenych modulov urcime vsetky cesty. Prepojenie A->B, jedna cesta je v tvare napriklad 1,1; 1,2; 2,2; 3,2; 3,3 
                 *     |_A_|  |___|  |___|
                 *      ___1,1 ___2,1 ___ 3,1
                 *     |___|  |___|  |___|
                 *      ___2,1 ___2,2 ___ 3,2
                 *     |___|  |___|  |_B_|
                 *         3,1    3,2     3,3
                 * 
                 * 
                 * */
                foreach (List<String> zaznam in universalList)
                {
                    int[] smery = new int[4];
                    int cnt2 = 0;

                    a = zaznam[0];
                    aport = zaznam[1];
                    b = zaznam[2];
                    bport = zaznam[3];
                    absignal = Int32.Parse(zaznam[4]);
                    matrixax = 0; matrixay = 0; matrixbx = 0; matrixby = 0;
                    maxx = matrix.Count;

                    //vyhladame pozicie modulov a a b v mriezke
                    for (i = 0; i < matrix.Count; i++)
                    {
                        for (j = 0; j < matrix[i].Count; j++)
                        {
                            if (matrix[i].Count > maxy)
                            {
                                maxy = matrix[i].Count;
                            }
                            if (matrix[i][j].Equals(a))
                            {
                                matrixax = i;
                                matrixay = j;
                            }
                            if (matrix[i][j].Equals(b))
                            {
                                matrixbx = i;
                                matrixby = j;
                            }
                        }
                    }

                    //teraz musime vyskusat vsetky cesty 
                    //path suradnice> x aj y su od 00 do maxx,maxy vratane


                    //a hore, b hore
                    smery[0] = 0;
                    matrixax++;

                    //smeruje vpravo hore
                    if ((matrixax < matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vpravo dole
                    if ((matrixax < matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo hore
                    if ((matrixax > matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo dole
                    if ((matrixax > matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //vodorovne
                    if (matrixay == matrixby)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }
                    //zvislo
                    if (matrixax == matrixbx)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }


                    //a hore, b dole
                    matrixby++;
                    smery[1] = cnt2;
                    //smeruje vpravo hore
                    if ((matrixax < matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vpravo dole
                    if ((matrixax < matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo hore
                    if ((matrixax > matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo dole
                    if ((matrixax > matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //vodorovne
                    if (matrixay == matrixby)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }
                    //zvislo
                    if (matrixax == matrixbx)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }

                    //a dole, b hore
                    smery[2] = cnt2;
                    matrixay++;
                    matrixby--;
                    //smeruje vpravo hore
                    if ((matrixax < matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vpravo dole
                    if ((matrixax < matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo hore
                    if ((matrixax > matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo dole
                    if ((matrixax > matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //vodorovne
                    if (matrixay == matrixby)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }
                    //zvislo
                    if (matrixax == matrixbx)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }

                    //a dole, b dole
                    smery[3] = cnt2;
                    matrixby++;
                    //smeruje vpravo hore
                    if ((matrixax < matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vpravo dole
                    if ((matrixax < matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixbx - matrixax + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixbx - matrixax))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixbx - matrixax)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax + t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo hore
                    if ((matrixax > matrixbx) && (matrixay > matrixby))
                    {
                        for (int s = 0; s < (matrixay - matrixby + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixay - matrixby)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay - s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //smeruje vlavo dole
                    if ((matrixax > matrixbx) && (matrixay < matrixby))
                    {
                        for (int s = 0; s < (matrixby - matrixay + 1); s++)
                        {
                            //prvy riadok
                            if (s == 0)
                            {
                                for (int t = 0; t < (matrixax - matrixbx + 1); t++)
                                {
                                    if (t == 0)
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixax + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if (t == (matrixax - matrixbx))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixay);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                    if ((t > 0) && (t < (matrixax - matrixbx)))
                                    {
                                        path[cnt].Add(new List<string>());
                                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixay);
                                        path[cnt][cnt2].Add((matrixax - t).ToString() + "," + matrixby);
                                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                        cnt2++;
                                    }
                                }
                            }
                            if ((s != 0) && (s != (matrixby - matrixay)))//riadky okrem prveho a posledneho
                            {
                                path[cnt].Add(new List<string>());
                                path[cnt][cnt2].Add(matrixax + "," + matrixay);
                                path[cnt][cnt2].Add(matrixax + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + (matrixay + s).ToString());
                                path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                                cnt2++;
                            }
                        }
                    }
                    //vodorovne
                    if (matrixay == matrixby)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }
                    //zvislo
                    if (matrixax == matrixbx)
                    {
                        path[cnt].Add(new List<string>());
                        path[cnt][cnt2].Add(matrixax + "," + matrixay);
                        path[cnt][cnt2].Add(matrixbx + "," + matrixby);
                        cnt2++;
                    }
                    //vsetky cesty ulozene, vratime pozicie a a b do default polohy
                    matrixax--;
                    matrixay--;
                    matrixby--;

                    //uprava pre priame linky - ak su prepojene 2 moduly v rovnakom riadku a medzi nimi uz nic nie je, mozeme tahat signal priamo
                    Boolean jePriamaLinka = true;
                    if ((matrixay == matrixby) && (matrixax < matrixbx))//rovnaky riadok
                    {
                        for (int k = Math.Min(matrixax, matrixbx) + 1; k < Math.Max(matrixax, matrixbx); k++)
                        {
                            if ((!(matrix[k][matrixay].Equals(""))))
                                jePriamaLinka = false;
                        }
                    }
                    if (jePriamaLinka && ((matrixay == matrixby) && (matrixax < matrixbx)))  //ak medzi modulmi nic nieje && maju rovnaku y poziciu && su usporiadane A---->B
                    {
                        //vymaze vsetky cesty
                        while (path[cnt].Count > 1)
                            path[cnt].RemoveAt(1);
                        while (path[cnt][0].Count > 0)
                            path[cnt][0].RemoveAt(0);
                        path[cnt][0].Add("0,255");  //priorita - 0,255 urcuje priamu linku
                    }
                    else//pre vsetky nepriame linky
                    {
                        foreach (List<string> polozka in path[cnt])
                        {
                            polozka.Add("0,0"); //priorita 0,0 - zaciatocna
                        }
                    }



                    //vymazanie hornych a spodnych liniek - tade nie je mozne viest signal
                    i = 0;
                    while (i < path[cnt].Count)
                    {
                        Boolean jeHornaDolnaLinka = false;
                        //tu zistime, ci je to horna alebo spodna linka, a to tak, ze porovname ci su dva body vedla seba rovnake v y-pozicii a rozne v x-pozicii
                        for (j = 0; j < path[cnt][i].Count - 1; j++)
                        {
                            int prve, druhe;
                            index = path[cnt][i][j].IndexOf(",");
                            prve = Int32.Parse(path[cnt][i][j].Substring(index + 1));
                            index = path[cnt][i][j + 1].IndexOf(",");
                            druhe = Int32.Parse(path[cnt][i][j + 1].Substring(index + 1));
                            if (((prve == 0) && (druhe == 0)) || ((prve == maxMatrixHeight) && (druhe == maxMatrixHeight)))
                                jeHornaDolnaLinka = true;
                        }
                        if (jeHornaDolnaLinka)//rovna sa
                        {
                            path[cnt].RemoveAt(i);
                        }
                        else
                        {
                            i++;
                        }
                    }

                    index = 0;

                    while (index < path[cnt].Count)
                    {
                        int pocet = 0;
                        List<string> tmp = new List<string>();
                        tmp = (path[cnt][index]);
                        foreach (List<string> polozka in path[cnt])
                        {
                            if (polozka.Count == tmp.Count)
                            {
                                Boolean rovnasa = true;
                                for (j = 0; j < polozka.Count; j++)
                                {
                                    if (!(polozka[j].Equals(tmp[j])))
                                        rovnasa = false;
                                }
                                if (rovnasa == true)
                                    pocet++;
                            }
                        }
                        for (j = 0; j < pocet - 1; j++)
                            path[cnt].Remove(tmp);
                        if (pocet == 1)
                            index++;
                    }

                    //teraz doplnime dalsie body, ktore su v strede medzi dvoma bodmi pathu (priklad> 1,1; 4,1 doplnime na 1,1; 2,1; 3,1; 4,1)
                    for (i = 0; i < path[cnt].Count; i++)
                    {
                        int pocet = 0;
                        if (path[cnt][i].Count > 2)
                        {

                            while (!(path[cnt][i][pocet + 1].Equals("0,0")))
                            {
                                index = 0;
                                int ax, bx, cx, dx;
                                index = path[cnt][i][pocet].IndexOf(",");
                                ax = Int32.Parse(path[cnt][i][pocet].Substring(0, index));
                                bx = Int32.Parse(path[cnt][i][pocet].Substring(index + 1));
                                index = path[cnt][i][pocet + 1].IndexOf(",");
                                cx = Int32.Parse(path[cnt][i][pocet + 1].Substring(0, index));
                                dx = Int32.Parse(path[cnt][i][pocet + 1].Substring(index + 1));
                                if ((ax == cx) && (Math.Abs(bx - dx) > 1))
                                {
                                    if (bx < dx)
                                    {
                                        for (j = 0; j < ((dx - bx) - 1); j++)
                                        {
                                            path[cnt][i].Insert((pocet + 1 + j), (ax + "," + (bx + 1 + j)));
                                        }
                                    }
                                    if (bx > dx)
                                    {
                                        for (j = 0; j < ((bx - dx) - 1); j++)
                                        {
                                            path[cnt][i].Insert((pocet + 1 + j), (ax + "," + (bx - 1 - j)));
                                        }
                                    }

                                }
                                if ((bx == dx) && (Math.Abs(ax - cx) > 1))
                                {
                                    if (ax < cx)
                                    {
                                        for (j = 0; j < ((cx - ax) - 1); j++)
                                        {
                                            path[cnt][i].Insert((pocet + 1 + j), ((ax + 1 + j) + "," + bx));
                                        }
                                    }
                                    if (ax > cx)
                                    {
                                        for (j = 0; j < ((ax - cx) - 1); j++)
                                        {
                                            path[cnt][i].Insert((pocet + 1 + j), ((ax - 1 - j) + "," + bx));
                                        }
                                    }

                                }
                                pocet++;
                            }

                        }
                    }

                    //teraz zvacsime prioritu tym cestam, ktore idu z hora alebo z dola
                    //tu by bolo neskor vhodne vlozit aj poziciu portu v module
                    for (i = 0; i < path[cnt].Count; i++)
                    {
                        if (matrixay > matrixby)    //A je nizsie ako B, A horne, B dolne
                        {
                            int pozicia1, pozicia2;
                            index = path[cnt][i][0].IndexOf(",");
                            pozicia1 = Int32.Parse(path[cnt][i][0].Substring(index + 1));
                            index = path[cnt][i][path[cnt][i].Count - 2].IndexOf(",");
                            pozicia2 = Int32.Parse(path[cnt][i][path[cnt][i].Count - 2].Substring(index + 1));
                            index = 0;
                            if (pozicia1 == matrixay)
                                index++;
                            if (pozicia2 == (matrixby + 1))
                                index++;
                            path[cnt][i].RemoveAt(path[cnt][i].Count - 1);
                            path[cnt][i].Add("0," + index);
                        }

                        if (matrixay < matrixby)    //B je nizsie ako A, A dolne, B horne
                        {
                            int pozicia1, pozicia2;
                            index = path[cnt][i][0].IndexOf(",");
                            pozicia1 = Int32.Parse(path[cnt][i][0].Substring(index + 1));
                            index = path[cnt][i][path[cnt][i].Count - 2].IndexOf(",");
                            pozicia2 = Int32.Parse(path[cnt][i][path[cnt][i].Count - 2].Substring(index + 1));
                            index = 0;
                            if (pozicia1 == (matrixay + 1))
                                index++;
                            if (pozicia2 == matrixby)
                                index++;
                            path[cnt][i].RemoveAt(path[cnt][i].Count - 1);
                            path[cnt][i].Add("0," + index);
                        }

                    }

                    cnt++;
                }
                /*
                 * 
                 * 
                 * 
                 * v tomto momente mame path naplneny - teda vsetky mozne cesty z modulu A do B
                 * 
                 * 
                 * 
                 * */

                List<int> visitedSignals = new List<int>();
                foreach (List<String> zaznam in universalList)
                {
                    string amod = zaznam[0];
                    int signal = Int32.Parse(zaznam[4]);
                    if (!(visitedSignals.Contains(signal)))
                    {
                        Boolean normalnySmer = true;
                        visitedSignals.Add(signal);
                        List<int> indexy = new List<int>();
                        indexy.Add(universalList.IndexOf(zaznam));
                        foreach (List<String> zaznam2 in universalList)
                        {
                            string amod2 = zaznam2[0];
                            int signal2 = Int32.Parse(zaznam2[4]);
                            if ((!(zaznam.Equals(zaznam2))) && (signal == signal2) && (path[universalList.IndexOf(zaznam2)][0].Count != 1))    //prva podmienka potencionalny problem
                            {
                                indexy.Add(universalList.IndexOf(zaznam2));
                                if (!(amod.Equals(amod2)))
                                    normalnySmer = false;
                            }

                        }
                        //indexy obsahuju indexy, ktore tvoria jeden signal
                        if (indexy.Count > 1)
                        {
                            List<int> priority = new List<int>();
                            foreach (int polozka in indexy)
                            {
                                int max = 0;
                                //int index3;
                                for (j = 0; j < path[polozka].Count; j++)
                                {
                                    index = path[polozka][j][path[polozka][j].Count - 1].IndexOf(",");
                                    index += 1;
                                    if (Int32.Parse(path[polozka][j][path[polozka][j].Count - 1].Substring(index)) > max)
                                        max = Int32.Parse(path[polozka][j][path[polozka][j].Count - 1].Substring(index));

                                }
                                priority.Add(max);

                            }
                            //zacneme s najvacsimi prioritami

                            List<string> porovnanie = null;
                            int indexporovnania = 0;
                            foreach (int indexpolozka in indexy)
                            {
                                foreach (List<string> polozka in path[indexpolozka])
                                {
                                    int cislo, index4;
                                    int index5 = path[indexpolozka][path[indexpolozka].IndexOf(polozka)].Count;
                                    index4 = path[indexpolozka][path[indexpolozka].IndexOf(polozka)][index5 - 1].IndexOf(",");
                                    cislo = Int32.Parse(path[indexpolozka][path[indexpolozka].IndexOf(polozka)][index5 - 1].Substring(index4 + 1));
                                    if (cislo == priority[indexy.IndexOf(indexpolozka)])
                                    {
                                        indexporovnania = indexpolozka;
                                        porovnanie = path[indexpolozka][path[indexpolozka].IndexOf(polozka)];
                                        //teraz prejdeme vsetky ostatne a budeme hladat zhodu
                                        for (int k = 0; k < indexy.Count; k++)
                                        {
                                            int aktindex = indexy[k];

                                            if (aktindex != indexporovnania)
                                            {
                                                for (int l = 0; l < path[aktindex].Count; l++)
                                                {
                                                    int cislo2, index42;
                                                    int index52 = path[aktindex][l].Count;
                                                    index42 = path[aktindex][l][index52 - 1].IndexOf(",");
                                                    cislo2 = Int32.Parse(path[aktindex][l][index52 - 1].Substring(index42 + 1));
                                                    if (cislo2 == cislo)//tu som zmenil aktindex na k//priority[k] tu bolo povodne
                                                    {
                                                        //teraz uz porovname retazce
                                                        if (normalnySmer)
                                                        {
                                                            int velkost1 = porovnanie.Count;
                                                            int velkost2 = path[aktindex][l].Count;
                                                            int pridaniePriority = 0;
                                                            int index6 = 0;
                                                            while ((index6 < (velkost1 - 1)) && (index6 < (velkost2 - 1)))
                                                            {
                                                                if (porovnanie[index6].Equals(path[aktindex][l][index6]))
                                                                {
                                                                    pridaniePriority++;
                                                                }
                                                                index6++;
                                                            }
                                                            int index7 = path[aktindex][l][path[aktindex][l].Count - 1].IndexOf(",");
                                                            int polka1, polka2;
                                                            polka1 = Int32.Parse(path[aktindex][l][path[aktindex][l].Count - 1].Substring(0, index7));
                                                            polka2 = Int32.Parse(path[aktindex][l][path[aktindex][l].Count - 1].Substring(index7 + 1));
                                                            polka1 += pridaniePriority;
                                                            path[aktindex][l].RemoveAt(path[aktindex][l].Count - 1);
                                                            path[aktindex][l].Add(polka1 + "," + polka2);
                                                        }
                                                        else
                                                        {

                                                            int pridaniePriority = 0;
                                                            int index61 = porovnanie.Count - 2;
                                                            int index62 = path[aktindex][l].Count - 2;
                                                            while ((index61 >= 0) && (index62 >= 0))
                                                            {
                                                                if (porovnanie[index61].Equals(path[aktindex][l][index62]))
                                                                {
                                                                    pridaniePriority++;
                                                                }
                                                                index61--;
                                                                index62--;
                                                            }
                                                            int index7 = path[aktindex][l][path[aktindex][l].Count - 1].IndexOf(",");
                                                            int polka1, polka2;
                                                            polka1 = Int32.Parse(path[aktindex][l][path[aktindex][l].Count - 1].Substring(0, index7));
                                                            polka2 = Int32.Parse(path[aktindex][l][path[aktindex][l].Count - 1].Substring(index7 + 1));
                                                            polka1 += pridaniePriority;
                                                            path[aktindex][l].RemoveAt(path[aktindex][l].Count - 1);
                                                            path[aktindex][l].Add(polka1 + "," + polka2);
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }

                //vymazeme cesty a nechat len po jednej - s najvacsou prioritou
                for (i = 0; i < path.Count; i++)
                {
                    if (path[i].Count > 1)
                    {
                        int maxa, maxb, posa, posb, pos;
                        maxa = 0;
                        maxb = 0;
                        pos = 0;

                        for (j = 0; j < path[i].Count; j++)
                        {
                            index = path[i][j][path[i][j].Count - 1].IndexOf(",");
                            posa = Int32.Parse(path[i][j][path[i][j].Count - 1].Substring(0, index));
                            posb = Int32.Parse(path[i][j][path[i][j].Count - 1].Substring(index + 1));
                            if (posa > maxa)
                            {
                                maxa = posa;
                                maxb = posb;
                                pos = j;
                            }
                            if (posa == maxa)
                                if (posb > maxb)
                                {
                                    maxb = posb;
                                    pos = j;
                                }

                        }
                        for (int k = 0; k < pos; k++)
                            path[i].RemoveAt(0);
                        while (path[i].Count > 1)
                            path[i].RemoveAt(1);
                    }
                }
                
                //teraz mame po jednej ceste

                //Oprava Pathu pre hodinove signaly
                foreach (List<String> item in universalList)
                {
                    if (item[5] == "true")
                    {
                        index = universalList.IndexOf(item);
                        i = path[index][0][0].IndexOf(',');
                        i = Int32.Parse(path[index][0][0].Substring(0, i)); //prve cislo v path
                        j = 0;
                        for (j = 0; j < path[index][0].Count; j++)
                        {
                            int ind = path[index][0][j].IndexOf(',');
                            int tmp = Int32.Parse(path[index][0][j].Substring(0, ind));
                            if ((tmp == i) && (tmp != 0))
                            {
                                path[index][0][j] = --tmp + path[index][0][j].Substring(ind);
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }

                //teraz uz dorobime finalne trasy signalov
                //najprv dame vsetky signaly do stredu medzier medzi modulmi
                List<List<string>> final = new List<List<string>>();
                dlzka = ((medzera + 50) / 2);
                for (i = 0; i < path.Count; i++)
                {
                    final.Add(new List<string>());
                    a = universalList[i][0];
                    aport = universalList[i][1];
                    b = universalList[i][2];
                    bport = universalList[i][3];
                    absignal = Int32.Parse(universalList[i][4]);

                    foreach (Modules modul in list)
                    {
                        if (((modul.GetName().Equals(a)) || ((modul.GetName().Equals(list[nadradenyindex].GetName())) && ((a.Equals("A$module"))))))
                        {
                            foreach (Ports port in modul.GetPortList())
                            {
                                if (port.GetName().Equals(aport))
                                {
                                    if ((nadradenyindex != -1) && (list.IndexOf(modul) == nadradenyindex))
                                    {
                                        //opacne a nadradeny / neviem ci bude treba opacne
                                        if (port.GetRotate().Equals(Direction.Right))   //out port
                                        {

                                            final[i].Add((port.GetPosX2() - 20) + "," + (port.GetPosY2() + 10));//opravit
                                            final[i].Add((port.GetPosX2() - dlzka) + "," + (port.GetPosY2() + 10));//opravit
                                        }
                                        if (port.GetRotate().Equals(Direction.Left))   //opacne port
                                        {
                                            final[i].Add((port.GetPosX2() + 20) + "," + (port.GetPosY2() + 10));//opravit
                                            final[i].Add((port.GetPosX2() + dlzka) + "," + (port.GetPosY2() + 10));//opravit
                                        }
                                    }
                                    else
                                    {
                                        if (port.GetRotate().Equals(Direction.Right))   //out port
                                        {
                                            final[i].Add((port.GetPosX1() + 20) + "," + (port.GetPosY1() + 10));//opravit
                                            final[i].Add((port.GetPosX1() + dlzka) + "," + (port.GetPosY1() + 10));//opravit
                                        }
                                        if (port.GetRotate().Equals(Direction.Left))   //opacne port
                                        {
                                            final[i].Add((port.GetPosX1() - 20) + "," + (port.GetPosY1() + 10));//opravit
                                            final[i].Add((port.GetPosX1() - dlzka) + "," + (port.GetPosY1() + 10));//opravit
                                        }
                                    }
                                }
                            }
                        }
                    }
                    //prvy a druhy uzol mame
                    //teraz stred

                    for (j = 0; j < (path[i][0].Count - 1); j++)
                    {
                        dlzka2 = path[i][0][j].IndexOf(",");
                        int prve = Int32.Parse(path[i][0][j].Substring(0, dlzka2));
                        int druhe = Int32.Parse(path[i][0][j].Substring(dlzka2 + 1));
                        prve = ((0 + (prve * (250 + medzera))) - ((medzera + 50) / 2));
                        druhe = verticalPoint[druhe] - (medzera / 2);
                        final[i].Add(prve + "," + druhe);
                    }

                    //posledny a predposledny
                    foreach (Modules modul in list)
                    {
                        if (((modul.GetName().Equals(b)) || ((modul.GetName().Equals(list[nadradenyindex].GetName())) && ((b.Equals("B$module"))))))
                        {
                            foreach (Ports port in modul.GetPortList())
                            {
                                if (port.GetName().Equals(bport))
                                {
                                    if ((nadradenyindex != -1) && (list.IndexOf(modul) == nadradenyindex))
                                    {//opacne - neviem ci treba
                                        if (port.GetRotate().Equals(Direction.Right))   //out port
                                        {


                                            final[i].Add((port.GetPosX2() - dlzka) + "," + (port.GetPosY2() + 10));//opravit
                                            final[i].Add((port.GetPosX2() - 20) + "," + (port.GetPosY2() + 10));//opravit
                                        }
                                        if (port.GetRotate().Equals(Direction.Left))   //opacne port
                                        {

                                            final[i].Add((port.GetPosX2() + dlzka) + "," + (port.GetPosY2() + 10));//opravit
                                            final[i].Add((port.GetPosX2() + 20) + "," + (port.GetPosY2() + 10));//opravit
                                        }
                                    }
                                    else
                                    {
                                        if (port.GetRotate().Equals(Direction.Right))   //out port
                                        {

                                            final[i].Add((port.GetPosX1() + dlzka) + "," + (port.GetPosY1() + 10));//opravit
                                            final[i].Add((port.GetPosX1() + 20) + "," + (port.GetPosY1() + 10));//opravit
                                        }
                                        if (port.GetRotate().Equals(Direction.Left))   //opacne port
                                        {

                                            final[i].Add((port.GetPosX1() - dlzka) + "," + (port.GetPosY1() + 10));//opravit
                                            final[i].Add((port.GetPosX1() - 20) + "," + (port.GetPosY1() + 10));//opravit
                                        }
                                    }
                                }
                            }
                        }
                    }

                    //teraz premazeme duplikaty
                    int k = 0;
                    while (k < (final[i].Count - 1))
                    {
                        if (final[i][k].Equals(final[i][k + 1]))
                        {
                            final[i].RemoveAt(k + 1);
                        }
                        else
                        {
                            k++;
                        }
                    }

                    //zmazanie liniek, kde su nepotrebne body
                    k = 0;
                    if (final[i].Count > 2)
                    {
                        while (k < (final[i].Count - 2))
                        {
                            index = final[i][k].IndexOf(",");
                            int zac01 = Int32.Parse(final[i][k].Substring(0, index));
                            int kon01 = Int32.Parse(final[i][k].Substring(index + 1));
                            index = final[i][k + 1].IndexOf(",");
                            int zac02 = Int32.Parse(final[i][k + 1].Substring(0, index));
                            int kon02 = Int32.Parse(final[i][k + 1].Substring(index + 1));
                            index = final[i][k + 2].IndexOf(",");
                            int zac03 = Int32.Parse(final[i][k + 2].Substring(0, index));
                            int kon03 = Int32.Parse(final[i][k + 2].Substring(index + 1));
                            if ((zac01 == zac02) && (zac02 == zac03) || (kon01 == kon02) && (kon02 == kon03))
                            {
                                final[i].RemoveAt(k + 1);
                            }
                            else
                            {
                                k++;
                            }
                        }
                    }

                }
                
                //signaly mame v strede, aj s nepotrebnymi uzlami
                //teraz poposuvame signaly tak, aby sa neprekryvali
                List<List<string>> signalposun = new List<List<string>>();
                index = 0;
                foreach (List<String> polozka in final)
                {
                    //zistime nazov signalu
                    int signal = Int32.Parse(universalList[final.IndexOf(polozka)][4]);
                    if (polozka.Count > 3)
                    {
                        j = 0;
                        for (i = 1; i < (polozka.Count - 1); i++)
                        {
                            int pom = polozka[i].IndexOf(",");
                            int zac = Int32.Parse(polozka[i].Substring(0, pom));
                            int kon = Int32.Parse(polozka[i].Substring(pom + 1));
                            if (i == 1)
                                j = 1;
                            if (j == 1)
                            {
                                signalposun.Add(new List<string>());
                                signalposun[index].Add(signal.ToString());
                                signalposun[index].Add(polozka[i]);
                            }
                            else if (j == 2)
                            {
                                signalposun[index].Add(polozka[i]);
                            }
                            else
                            {
                                //pozrieme posledne 2 a ci treti pasuje

                                int pom1 = signalposun[index][j - 2].IndexOf(",");
                                int zac1 = Int32.Parse(signalposun[index][j - 2].Substring(0, pom1));
                                int kon1 = Int32.Parse(signalposun[index][j - 2].Substring(pom1 + 1));
                                pom1 = signalposun[index][j - 1].IndexOf(",");
                                int zac2 = Int32.Parse(signalposun[index][j - 1].Substring(0, pom1));
                                int kon2 = Int32.Parse(signalposun[index][j - 1].Substring(pom1 + 1));
                                if (((zac1 == zac2) && (zac1 == zac)) || ((kon1 == kon2) && (kon1 == kon)))
                                {//pasuje
                                    signalposun[index].Add(polozka[i]);
                                }
                                else
                                {
                                    signalposun.Add(new List<string>());
                                    index++;
                                    signalposun[index].Add(signal.ToString());
                                    signalposun[index].Add(polozka[i - 1]);
                                    signalposun[index].Add(polozka[i]);
                                    j = 2;
                                }
                            }
                            j++;
                        }
                        index++;
                    }

                }
                //v signalposun mame vzdy cislo signalu a nody, ktore tvoria jednu ciaru - vsetky ciaru su takto dane okrem zaciatocnych a koncovych, tie sa posuvat nejdu
                //teraz asi poskladame suvisle ciary z viacerych ciar
                
                foreach (List<string> polozka in signalposun)
                {
                    if (polozka.Count != 1)
                    {

                        int zac1, zac2, kon1, kon2;
                        if (polozka.Count > 2)
                        {
                            index = polozka[1].IndexOf(",");
                            zac1 = Int32.Parse(polozka[1].Substring(0, index));
                            kon1 = Int32.Parse(polozka[1].Substring(index + 1));
                            index = polozka[2].IndexOf(",");
                            zac2 = Int32.Parse(polozka[2].Substring(0, index));
                            kon2 = Int32.Parse(polozka[2].Substring(index + 1));
                        }
                        else
                        {
                            break;
                        }
                        foreach (List<string> polozka2 in signalposun)
                        {
                            if (signalposun.IndexOf(polozka) != signalposun.IndexOf(polozka2))
                            {
                                if (polozka2.Count != 1)
                                {
                                    if (polozka[0].Equals(polozka2[0]))
                                    {
                                        if (polozka2.Count > 2)
                                        {
                                            index = polozka2[1].IndexOf(",");
                                            int tmpzac1 = Int32.Parse(polozka2[1].Substring(0, index));
                                            int tmpkon1 = Int32.Parse(polozka2[1].Substring(index + 1));
                                            index = polozka2[2].IndexOf(",");
                                            int tmpzac2 = Int32.Parse(polozka2[2].Substring(0, index));
                                            int tmpkon2 = Int32.Parse(polozka2[2].Substring(index + 1));
                                            if (((zac1 == zac2) && (tmpzac1 == tmpzac2) && (zac1 == tmpzac1)) || ((kon2 == kon1) && (tmpkon1 == tmpkon2) && (kon1 == tmpkon1)))//sedi
                                            {
                                                while (polozka2.Count > 1)
                                                {
                                                    if (!(polozka.Contains(polozka2[1])))
                                                    {
                                                        polozka.Add(polozka2[1]);
                                                    }
                                                    polozka2.RemoveAt(1);
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                
                for (i = 0; i < signalposun.Count; )
                {
                    if (signalposun[i].Count == 1)
                    {
                        signalposun.RemoveAt(i);
                    }
                    else
                    {
                        i++;
                    }
                }

                //teraz ideme zosortovat jednotlive riadky
                for (i = 0; i < signalposun.Count; i++)
                {
                    Boolean rastie, prvarovnaka;
                    rastie = false;
                    int stala = 0;
                    index = signalposun[i][1].IndexOf(",");
                    int zac1 = Int32.Parse(signalposun[i][1].Substring(0, index));
                    int kon1 = Int32.Parse(signalposun[i][1].Substring(index + 1));
                    index = signalposun[i][2].IndexOf(",");
                    int zac2 = Int32.Parse(signalposun[i][2].Substring(0, index));
                    int kon2 = Int32.Parse(signalposun[i][2].Substring(index + 1));
                    if (zac1 == zac2)
                        prvarovnaka = true;
                    else
                        prvarovnaka = false;
                    if (prvarovnaka && (kon1 > kon2))
                        rastie = false;
                    else if (prvarovnaka && (kon1 < kon2))
                        rastie = true;
                    else if ((!prvarovnaka) && (zac1 > zac2))
                        rastie = false;
                    else if ((!prvarovnaka) && (zac1 < zac2))
                        rastie = true;
                    if (prvarovnaka)
                        stala = zac1;
                    else
                        stala = kon1;
                    List<int> zoradeniecisla = new List<int>();
                    for (j = 1; j < signalposun[i].Count; j++)
                    {
                        index = signalposun[i][j].IndexOf(",");
                        zac1 = Int32.Parse(signalposun[i][j].Substring(0, index));
                        kon1 = Int32.Parse(signalposun[i][j].Substring(index + 1));
                        if (prvarovnaka)
                            zoradeniecisla.Add(kon1);
                        else
                            zoradeniecisla.Add(zac1);
                    }
                    zoradeniecisla.Sort();
                    while (signalposun[i].Count > 1)
                        signalposun[i].RemoveAt(1);
                    if (rastie)
                    {
                        if (prvarovnaka)
                        {
                            for (j = 0; j < zoradeniecisla.Count; j++)
                            {
                                signalposun[i].Add(stala + "," + zoradeniecisla[j]);
                            }
                        }
                        else
                        {
                            for (j = 0; j < zoradeniecisla.Count; j++)
                            {
                                signalposun[i].Add(zoradeniecisla[j] + "," + stala);
                            }
                        }
                    }
                    else //klesa
                    {
                        if (prvarovnaka)
                        {
                            for (j = (zoradeniecisla.Count - 1); j >= 0; j--)
                            {
                                signalposun[i].Add(stala + "," + zoradeniecisla[j]);
                            }
                        }
                        else
                        {
                            for (j = (zoradeniecisla.Count - 1); j >= 0; j--)
                            {
                                signalposun[i].Add(zoradeniecisla[j] + "," + stala);
                            }
                        }
                    }
                }

                //vypis finalu
                //foreach (List<string> polozka in final)
                //{
                //    Console.Out.Write(final.IndexOf(polozka) + ") ");
                //    foreach (string polozka2 in polozka)
                //    {
                //        Console.Out.Write(polozka2 + "  ");
                //    }
                //    Console.Out.WriteLine();
                //}

                //posuny signalov
                //zistime, kolko ciar je na rovnakej stalej pozicii, na tolko dielov rozdelime fugu a potom
                //vyskusame vsetky moznosti, pricom najlepsia moznost bude kde bude najmenej prekrizeni
                List<string> ciaryhor = new List<string>();
                List<string> ciaryver = new List<string>();
                List<List<string>> finalnovy = new List<List<string>>();
                foreach (List<string> polozka in final)
                {
                    finalnovy.Add(new List<string>());
                    foreach (string polozka2 in polozka)
                    {
                        finalnovy[final.IndexOf(polozka)].Add(polozka2);
                    }
                }



                foreach (List<string> polozka in signalposun)
                {
                    if (polozka.Count > 2)
                    {
                        Boolean prvarovnaka = false;
                        int stala = 0;
                        List<int> ovplyvnene = new List<int>();
                        List<int> ovplyvnene_stale = new List<int>();
                        List<int> ovplyvnene_naj = new List<int>();
                        index = polozka[1].IndexOf(",");
                        int zac1 = Int32.Parse(polozka[1].Substring(0, index));
                        int kon1 = Int32.Parse(polozka[1].Substring(index + 1));
                        index = polozka[2].IndexOf(",");
                        int zac2 = Int32.Parse(polozka[2].Substring(0, index));
                        int kon2 = Int32.Parse(polozka[2].Substring(index + 1));
                        if (zac1 == zac2)
                            prvarovnaka = true;
                        else
                            prvarovnaka = false;
                        if (prvarovnaka)
                        {
                            if (!(ciaryver.Contains(zac1.ToString())))
                            {
                                ciaryver.Add(zac1.ToString());
                                stala = zac1;
                                foreach (List<string> polozka2 in signalposun)
                                {
                                    if (polozka2.Count > 2)
                                    {

                                        index = polozka2[1].IndexOf(",");
                                        zac1 = Int32.Parse(polozka2[1].Substring(0, index));
                                        kon1 = Int32.Parse(polozka2[1].Substring(index + 1));
                                        index = polozka2[2].IndexOf(",");
                                        zac2 = Int32.Parse(polozka2[2].Substring(0, index));
                                        kon2 = Int32.Parse(polozka2[2].Substring(index + 1));
                                        if ((zac1 == zac2) && (zac1 == stala))
                                        {
                                            ovplyvnene_stale.Add(signalposun.IndexOf(polozka2));
                                        }
                                    }
                                }

                            }
                        }
                        else
                        {
                            if (!(ciaryhor.Contains(kon1.ToString())))
                            {
                                ciaryhor.Add(kon1.ToString());
                                stala = kon1;
                                foreach (List<string> polozka2 in signalposun)
                                {
                                    if (polozka2.Count > 2)
                                    {

                                        index = polozka2[1].IndexOf(",");
                                        zac1 = Int32.Parse(polozka2[1].Substring(0, index));
                                        kon1 = Int32.Parse(polozka2[1].Substring(index + 1));
                                        index = polozka2[2].IndexOf(",");
                                        zac2 = Int32.Parse(polozka2[2].Substring(0, index));
                                        kon2 = Int32.Parse(polozka2[2].Substring(index + 1));
                                        if ((kon1 == kon2) && (kon1 == stala))
                                        {
                                            ovplyvnene_stale.Add(signalposun.IndexOf(polozka2));
                                        }
                                    }
                                }
                            }
                        }


                        int prekrizenie = Int32.MaxValue;
                        int opakuj = 20;    //zaciatocne opakovanie 20 krat
                        List<List<int>> tmp = new List<List<int>>();

                        int ovplyvnenepocet3 = ovplyvnene.Count;
                        for (i = 0; i < ovplyvnenepocet3; i++)
                        {
                            ovplyvnene.RemoveAt(0);
                        }
                        foreach (int hodnota in ovplyvnene_stale)
                        {
                            ovplyvnene.Add(hodnota);
                        }
                        //Console.Out.WriteLine("stala je " + stala + " , prvarovnaka " + prvarovnaka.ToString());
                        int lokal_prekrizenia = 0;
                        while (opakuj > 0)
                        {
                            if (stala == 0)
                                break;
                            List<List<string>> finalnovy_akt = new List<List<string>>();
                            List<int> ovplyvnenemap = new List<int>();
                            if (stala != 0)
                            {
                                Random random = new Random();
                                int randnumber = 0;
                                if (tmp.Count != 0)
                                    randnumber = random.Next(0, tmp.Count - 1);

                                foreach (List<int> item in tmp) //swapovanie dvoch liniek (z predchadzajucej iteracie cyklu)
                                {
                                    if (lokal_prekrizenia < 10000)  //swapovanie dvoch liniek, ktore by malo vyriesit prekrizenie
                                    {
                                        if (tmp.IndexOf(item) == randnumber)
                                        {
                                            int tmpo = ovplyvnene[ovplyvnene.IndexOf(item[0])];
                                            int tmpo2 = ovplyvnene[ovplyvnene.IndexOf(item[1])];
                                            int index1 = ovplyvnene.IndexOf(item[0]);
                                            int index2 = ovplyvnene.IndexOf(item[1]);
                                            ovplyvnene[index1] = tmpo2;
                                            ovplyvnene[index2] = tmpo;
                                        }
                                    }
                                    else   //swapovanie vsetkych dvojic liniek, kedy dochadza k prekryvaniu liniek
                                    {
                                        int tmpo = ovplyvnene[ovplyvnene.IndexOf(item[0])];
                                        int tmpo2 = ovplyvnene[ovplyvnene.IndexOf(item[1])];
                                        int index1 = ovplyvnene.IndexOf(item[0]);
                                        int index2 = ovplyvnene.IndexOf(item[1]);
                                        ovplyvnene[index1] = tmpo2;
                                        ovplyvnene[index2] = tmpo;
                                    }
                                }

                                foreach (List<string> polozka3 in finalnovy)
                                {
                                    finalnovy_akt.Add(new List<string>());
                                    foreach (string polozka2 in polozka3)
                                    {
                                        finalnovy_akt[finalnovy.IndexOf(polozka3)].Add(polozka2);
                                    }
                                }


                                //posun polovice liniek dolava
                                int posun = (dlzka - 5) / ovplyvnene.Count;
                                for (int ss = 0; ss < (ovplyvnene.Count / 2); ss++)
                                {
                                    int posunuty = ovplyvnene[ss];
                                    //pre vsetky signaly, kde sa rovna meno a zaroven obsahuju hocaku z ovplyvnenych prvkov, posunie sa 
                                    foreach (List<string> polozka3 in final)
                                    {
                                        //polozka3[0] neobsahuje nazov signalu - ten si musim zistit                                        
                                        if (universalList[final.IndexOf(polozka3)][4].Equals(signalposun[posunuty][0]))
                                        {
                                            //polozka3 obsahuje dany signal, ktory ideme upravit hodnotami z signalposun2[posunuty]
                                            for (int t = 0; t < polozka3.Count; t++)
                                            {
                                                if (signalposun[posunuty].Contains(polozka3[t]))
                                                {
                                                    index = finalnovy_akt[final.IndexOf(polozka3)][t].IndexOf(",");
                                                    int zacx = Int32.Parse(finalnovy_akt[final.IndexOf(polozka3)][t].Substring(0, index));
                                                    int konx = Int32.Parse(finalnovy_akt[final.IndexOf(polozka3)][t].Substring(index + 1));
                                                    finalnovy_akt[final.IndexOf(polozka3)].RemoveAt(t);
                                                    string najdeny = signalposun[posunuty][signalposun[posunuty].IndexOf(polozka3[t])];
                                                    index = najdeny.IndexOf(",");
                                                    zac1 = Int32.Parse(najdeny.Substring(0, index));
                                                    kon1 = Int32.Parse(najdeny.Substring(index + 1));
                                                    if (prvarovnaka)
                                                    {
                                                        finalnovy_akt[final.IndexOf(polozka3)].Insert(t, (zac1 - (((ovplyvnene.Count / 2) - ss) * posun)) + "," + konx);
                                                        if (ovplyvnenemap.Count == ss)
                                                            ovplyvnenemap.Add((zac1 - (((ovplyvnene.Count / 2) - ss) * posun)));
                                                    }
                                                    else
                                                    {
                                                        finalnovy_akt[final.IndexOf(polozka3)].Insert(t, zacx + "," + (kon1 - (((ovplyvnene.Count / 2) - ss) * posun)));
                                                        if (ovplyvnenemap.Count == ss)
                                                            ovplyvnenemap.Add((kon1 - (((ovplyvnene.Count / 2) - ss) * posun)));
                                                    }

                                                }
                                            }

                                        }
                                    }
                                }
                                //posun druhej polovice liniek doprava
                                for (int ss = (ovplyvnene.Count / 2); ss < ovplyvnene.Count; ss++)
                                {
                                    int posunuty = ovplyvnene[ss];
                                    //pre vsetky signaly, kde sa rovna meno a zaroven obsahuju hocaku z ovplyvnenych prvkov, posunie sa 
                                    foreach (List<string> polozka3 in final)
                                    {
                                        if (universalList[final.IndexOf(polozka3)][4].Equals(signalposun[posunuty][0]))
                                        {
                                            //polozka3 obsahuje dany signal, ktory ideme upravit hodnotami z signalposun2[posunuty]
                                            for (int t = 0; t < polozka3.Count; t++)
                                            {
                                                if (signalposun[posunuty].Contains(polozka3[t]))
                                                {
                                                    index = finalnovy_akt[final.IndexOf(polozka3)][t].IndexOf(",");
                                                    int zacx = Int32.Parse(finalnovy_akt[final.IndexOf(polozka3)][t].Substring(0, index));
                                                    int konx = Int32.Parse(finalnovy_akt[final.IndexOf(polozka3)][t].Substring(index + 1));
                                                    finalnovy_akt[final.IndexOf(polozka3)].RemoveAt(t);
                                                    string najdeny = signalposun[posunuty][signalposun[posunuty].IndexOf(polozka3[t])];
                                                    index = najdeny.IndexOf(",");
                                                    zac1 = Int32.Parse(najdeny.Substring(0, index));
                                                    kon1 = Int32.Parse(najdeny.Substring(index + 1));                                                    
                                                    if (prvarovnaka)
                                                    {
                                                        finalnovy_akt[final.IndexOf(polozka3)].Insert(t, (zac1 + ((ss - (ovplyvnene.Count / 2)) * posun)) + "," + konx);
                                                        if (ovplyvnenemap.Count == ss)
                                                            ovplyvnenemap.Add((zac1 + ((ss - (ovplyvnene.Count / 2)) * posun)));
                                                    }
                                                    else
                                                    {
                                                        finalnovy_akt[final.IndexOf(polozka3)].Insert(t, zacx + "," + (kon1 + ((ss - (ovplyvnene.Count / 2)) * posun)));
                                                        if (ovplyvnenemap.Count == ss)
                                                            ovplyvnenemap.Add((kon1 + ((ss - (ovplyvnene.Count / 2)) * posun)));
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }

                            //vymazeme tmp - tie ciary, ktore treba vymenit
                            tmp = ClearList(tmp);
                            //teraz vypocitame prekrizenia nad finalnovy
                            lokal_prekrizenia = 0;
                          
                            List<List<int>> prekrizenia_posunute = new List<List<int>>();
                            List<List<int>> prekrizenia_okolie = new List<List<int>>();

                            //prekrizenia_posunute obsahuju ciary, ktore sa nachadzaju v jednej linii
                            foreach (List<string> lolozka in finalnovy_akt)
                            {
                                for (i = 0; i < (lolozka.Count - 1); i++)
                                {
                                    index = lolozka[i].IndexOf(",");
                                    int zac11 = Int32.Parse(lolozka[i].Substring(0, index));
                                    int kon11 = Int32.Parse(lolozka[i].Substring(index + 1));
                                    index = lolozka[i + 1].IndexOf(",");
                                    int zac21 = Int32.Parse(lolozka[i + 1].Substring(0, index));
                                    int kon21 = Int32.Parse(lolozka[i + 1].Substring(index + 1));
                                    if (prvarovnaka && (zac11 == zac21) && (Math.Abs(zac11 - stala) < medzera))
                                    {
                                        prekrizenia_posunute.Add(new List<int>());
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(zac11);
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(kon11);
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(zac21);
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(kon21);
                                    }
                                    if ((!prvarovnaka) && (kon11 == kon21) && (Math.Abs(kon11 - stala) < medzera))
                                    {
                                        prekrizenia_posunute.Add(new List<int>());
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(zac11);
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(kon11);
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(zac21);
                                        prekrizenia_posunute[prekrizenia_posunute.Count - 1].Add(kon21);
                                    }
                                }
                            }

                            //prekrizenia_okolie obsahuju ciary, ktore su kolme na ciary, ktore sa nachadzaju v jednej linii a zacinaju alebo koncia v tejto linii
                            foreach (List<string> lolozka in finalnovy_akt)
                            {
                                for (i = 0; i < (lolozka.Count - 1); i++)
                                {
                                    index = lolozka[i].IndexOf(",");
                                    int zac11 = Int32.Parse(lolozka[i].Substring(0, index));
                                    int kon11 = Int32.Parse(lolozka[i].Substring(index + 1));
                                    index = lolozka[i + 1].IndexOf(",");
                                    int zac21 = Int32.Parse(lolozka[i + 1].Substring(0, index));
                                    int kon21 = Int32.Parse(lolozka[i + 1].Substring(index + 1));
                                    if (prvarovnaka && (kon11 == kon21) && ((Math.Abs(zac11 - stala) < medzera) || (Math.Abs(zac21 - stala) < medzera)))
                                    {
                                        prekrizenia_okolie.Add(new List<int>());
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(zac11);
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(kon11);
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(zac21);
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(kon21);
                                    }
                                    if ((!prvarovnaka) && (zac11 == zac21) && ((Math.Abs(kon11 - stala) < medzera) || (Math.Abs(kon21 - stala) < medzera)))
                                    {
                                        prekrizenia_okolie.Add(new List<int>());
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(zac11);
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(kon11);
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(zac21);
                                        prekrizenia_okolie[prekrizenia_okolie.Count - 1].Add(kon21);
                                    }
                                }
                            }

                            //najprv pozrieme okolie, ci sa neprekryva okolie - nefunguje spravne 
                            for (i = 0; i < prekrizenia_okolie.Count; i++)
                            {
                                for (j = i + 1; j < prekrizenia_okolie.Count; j++)
                                {
                                    if (prvarovnaka)//okolie je horizontalne
                                    {
                                        if (prekrizenia_okolie[i][1] == prekrizenia_okolie[j][1])    //maju rovnaku y poziciu
                                        {
                                            if (((Math.Min(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) < prekrizenia_okolie[j][0]) && (Math.Max(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) > prekrizenia_okolie[j][0])) ^ ((Math.Min(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) < prekrizenia_okolie[j][2]) && (Math.Max(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) > prekrizenia_okolie[j][2])))
                                            {

                                                //problemove su :
                                                if ((Math.Min(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) < prekrizenia_okolie[j][0]) && (Math.Max(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) > prekrizenia_okolie[j][0]) && (Math.Max(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) != Math.Max(prekrizenia_okolie[j][0], prekrizenia_okolie[j][2])))
                                                {
                                                    lokal_prekrizenia += 10000;
                                                    tmp.Add(new List<int>());
                                                    //problemove su i - 2 a j - 0;
                                                    int mensie = prekrizenia_okolie[j][0];
                                                    int vacsie = prekrizenia_okolie[i][2];
                                                    tmp[tmp.Count - 1].Add(mensie);
                                                    tmp[tmp.Count - 1].Add(vacsie);
                                                }
                                                if ((Math.Min(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) < prekrizenia_okolie[j][2]) && (Math.Max(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) > prekrizenia_okolie[j][2]) && (Math.Min(prekrizenia_okolie[i][0], prekrizenia_okolie[i][2]) != Math.Min(prekrizenia_okolie[j][0], prekrizenia_okolie[j][2])))
                                                {
                                                    lokal_prekrizenia += 10000;
                                                    tmp.Add(new List<int>());
                                                    //problemove su i - 0 a j - 2
                                                    int mensie = prekrizenia_okolie[i][0];
                                                    int vacsie = prekrizenia_okolie[j][2];
                                                    tmp[tmp.Count - 1].Add(mensie);
                                                    tmp[tmp.Count - 1].Add(vacsie);
                                                }
                                            }
                                        }
                                    }
                                    if (!prvarovnaka)//okolie je vertikalne
                                    {
                                        if (prekrizenia_okolie[i][0] == prekrizenia_okolie[j][0])    //maju rovnaku x poziciu
                                        {
                                            if (((Math.Min(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) < prekrizenia_okolie[j][1]) && (Math.Max(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) > prekrizenia_okolie[j][1])) ^ ((Math.Min(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) < prekrizenia_okolie[j][3]) && (Math.Max(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) > prekrizenia_okolie[j][3])))
                                            {

                                                //problemove su :
                                                if ((Math.Min(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) < prekrizenia_okolie[j][1]) && (Math.Max(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) > prekrizenia_okolie[j][1]) && (Math.Max(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) != Math.Max(prekrizenia_okolie[j][1], prekrizenia_okolie[j][3])))
                                                {
                                                    lokal_prekrizenia += 10000;
                                                    tmp.Add(new List<int>());
                                                    //problemove su i - 3 a j - 1;
                                                    int mensie = prekrizenia_okolie[j][1];
                                                    int vacsie = prekrizenia_okolie[i][3];
                                                    tmp[tmp.Count - 1].Add(mensie);
                                                    tmp[tmp.Count - 1].Add(vacsie);
                                                }
                                                if ((Math.Min(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) < prekrizenia_okolie[j][3]) && (Math.Max(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) > prekrizenia_okolie[j][3]) && (Math.Min(prekrizenia_okolie[i][1], prekrizenia_okolie[i][3]) != Math.Min(prekrizenia_okolie[j][1], prekrizenia_okolie[j][3])))
                                                {
                                                    lokal_prekrizenia += 10000;
                                                    tmp.Add(new List<int>());
                                                    //problemove su i - 1 a j - 3
                                                    int mensie = prekrizenia_okolie[i][1];
                                                    int vacsie = prekrizenia_okolie[j][3];
                                                    tmp[tmp.Count - 1].Add(mensie);
                                                    tmp[tmp.Count - 1].Add(vacsie);
                                                }
                                            }
                                        }
                                    }
                                }
                            }

                            //teraz skontrolujeme prekrizenie hran - porovname posunute s okolim
                            if (lokal_prekrizenia < 10000)
                            {
                                for (i = 0; i < prekrizenia_posunute.Count; i++)
                                {
                                    for (j = 0; j < prekrizenia_okolie.Count; j++)
                                    {
                                        if (prvarovnaka)//hrany su vertikalne
                                        {
                                            //posunuty x je rovnake - index 0 a 2
                                            //okolie y je rovnake - index 1 a 3
                                            if ((Math.Min(prekrizenia_posunute[i][1], prekrizenia_posunute[i][3]) < prekrizenia_okolie[j][1]) && (Math.Max(prekrizenia_posunute[i][1], prekrizenia_posunute[i][3]) > prekrizenia_okolie[j][1]) && (Math.Min(prekrizenia_okolie[j][0], prekrizenia_okolie[j][2]) < prekrizenia_posunute[i][0]) && (Math.Max(prekrizenia_okolie[j][0], prekrizenia_okolie[j][2]) > prekrizenia_posunute[i][1]))
                                            {
                                                lokal_prekrizenia += 10;
                                                //zistim v okoli suradnicu, ktora je najblizsie ku stalej
                                                int suradnica = 0;
                                                if ((Math.Abs(prekrizenia_okolie[j][0] - stala) < Math.Abs(prekrizenia_okolie[j][2] - stala)) && (Math.Abs(prekrizenia_okolie[j][0] - stala) < (dlzka - 2)))
                                                    suradnica = prekrizenia_okolie[j][0];
                                                else if ((Math.Abs(prekrizenia_okolie[j][0] - stala) > Math.Abs(prekrizenia_okolie[j][2] - stala)) && (Math.Abs(prekrizenia_okolie[j][2] - stala) < (dlzka - 2)))
                                                    suradnica = prekrizenia_okolie[j][2];
                                                if (suradnica != 0)
                                                {
                                                    tmp.Add(new List<int>());
                                                    int mensie = prekrizenia_posunute[i][0];//len inicializacia
                                                    int vacsie = suradnica;                 //-//-
                                                    if (prekrizenia_posunute[i][0] < suradnica)
                                                    {
                                                        mensie = prekrizenia_posunute[i][0];
                                                        vacsie = suradnica;
                                                    }
                                                    else
                                                    {
                                                        mensie = suradnica;
                                                        vacsie = prekrizenia_posunute[i][0];
                                                    }
                                                    tmp[tmp.Count - 1].Add(mensie);
                                                    tmp[tmp.Count - 1].Add(vacsie);
                                                    //Console.Out.WriteLine("swapnem " + mensie + " a " + vacsie);
                                                }
                                            }
                                        }
                                        if (!prvarovnaka)//okolie je vertikalne
                                        {
                                            //posunuty y je rovnake - index 1 a 3
                                            //okolie x je rovnake - index 0 a 2
                                            if ((Math.Min(prekrizenia_posunute[i][0], prekrizenia_posunute[i][2]) < prekrizenia_okolie[j][0]) && (Math.Max(prekrizenia_posunute[i][0], prekrizenia_posunute[i][2]) > prekrizenia_okolie[j][0]) && (Math.Min(prekrizenia_okolie[j][1], prekrizenia_okolie[j][3]) < prekrizenia_posunute[i][1]) && (Math.Max(prekrizenia_okolie[j][1], prekrizenia_okolie[j][3]) > prekrizenia_posunute[i][1]))
                                            {
                                                lokal_prekrizenia += 10;
                                                int suradnica = 0;
                                                if ((Math.Abs(prekrizenia_okolie[j][1] - stala) < Math.Abs(prekrizenia_okolie[j][3] - stala)) && (Math.Abs(prekrizenia_okolie[j][1] - stala) < (dlzka - 2)))
                                                    suradnica = prekrizenia_okolie[j][1];
                                                else if ((Math.Abs(prekrizenia_okolie[j][1] - stala) > Math.Abs(prekrizenia_okolie[j][3] - stala)) && (Math.Abs(prekrizenia_okolie[j][3] - stala) < (dlzka - 2)))
                                                    suradnica = prekrizenia_okolie[j][3];
                                                if (suradnica != 0)
                                                {
                                                    tmp.Add(new List<int>());
                                                    int mensie = prekrizenia_posunute[i][1];//len inicializacia
                                                    int vacsie = suradnica;                 //-//-
                                                    if (prekrizenia_posunute[i][1] < suradnica)
                                                    {
                                                        mensie = prekrizenia_posunute[i][1];
                                                        vacsie = suradnica;
                                                    }
                                                    else
                                                    {
                                                        mensie = suradnica;
                                                        vacsie = prekrizenia_posunute[i][1];
                                                    }
                                                    tmp[tmp.Count - 1].Add(mensie);
                                                    tmp[tmp.Count - 1].Add(vacsie);
                                                    //Console.Out.WriteLine("swapnem " + mensie + " a " + vacsie);
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                            //teraz upravime robiazlobu - vymenime suradnice za pozicie v ovplyvnene
                            for (i = 0; i < tmp.Count; )
                            {
                                if ((!(ovplyvnenemap.Contains(tmp[i][0]))) || (!(ovplyvnenemap.Contains(tmp[i][1]))))
                                {
                                    tmp[i].RemoveAt(0);
                                    tmp[i].RemoveAt(0);
                                    tmp.RemoveAt(i);
                                }
                                else
                                {
                                    //ak index neni v ovplyvnenemap - delete
                                    tmp[i][0] = ovplyvnene[ovplyvnenemap.IndexOf(tmp[i][0])];
                                    tmp[i][1] = ovplyvnene[ovplyvnenemap.IndexOf(tmp[i][1])];
                                    i++;
                                }
                            }


                            for (i = 0; i < tmp.Count; )
                            {
                                Boolean nasielsa = false;
                                foreach (List<int> item in tmp)
                                {
                                    if (tmp.IndexOf(item) != i)
                                    {
                                        if ((item[0] == tmp[i][0]) && (item[1] == tmp[i][1]))
                                        {
                                            nasielsa = true;
                                            break;
                                        }
                                    }
                                }
                                if (nasielsa)
                                {
                                    tmp[i].RemoveAt(0);
                                    tmp[i].RemoveAt(0);
                                    tmp.RemoveAt(i);
                                }
                                else
                                {
                                    i++;
                                }
                            }

                            //porovname pocet prekrizeni a ak je lepsi, ulozime ho
                            if ((stala != 0) && (lokal_prekrizenia < prekrizenie))
                            {
                                prekrizenie = lokal_prekrizenia;
                                //Console.Out.WriteLine("vyhralo prekrizenie " + lokal_prekrizenia);


                                if (ovplyvnene_naj.Count != 0)
                                {
                                    int ovplyvnenepocet = ovplyvnene_naj.Count;
                                    for (j = 0; j < ovplyvnenepocet; j++)
                                    {
                                        ovplyvnene_naj.RemoveAt(0);
                                    }
                                }
                                int ovplyvnenepocet2 = ovplyvnene.Count;
                                for (j = 0; j < ovplyvnenepocet2; j++)
                                {
                                    ovplyvnene_naj.Add(ovplyvnene[j]);
                                }

                            }

                            //v pripade, ze sa okolie neprekryva, hladame uz len mensi pocet prekrizeni
                            if ((prekrizenie < 10000) && (opakuj > 4))
                                opakuj = 4;
                            //ak nie je potrebne robit ziadne zmeny
                            if (tmp.Count == 0)
                                break;
                            opakuj--;

                        }
                        //skoncil sa cyklus

                        int ovplyvnenepocettmp = ovplyvnene.Count;
                        for (j = 0; j < ovplyvnenepocettmp; j++)
                        {
                            ovplyvnene.RemoveAt(0);
                        }
                        ovplyvnenepocettmp = ovplyvnene_naj.Count;
                        for (j = 0; j < ovplyvnenepocettmp; j++)
                        {
                            ovplyvnene.Add(ovplyvnene_naj[j]);
                        }
                        //ovplyvnene je to najlepsie

                        //opat rozlozime ciery v jednej linii - teraz uz najvyhodnejsie
                        if (stala != 0)
                        {

                            int posun = (dlzka - 5) / ovplyvnene.Count;
                            for (int ss = 0; ss < (ovplyvnene.Count / 2); ss++)
                            {
                                int posunuty = ovplyvnene[ss];
                                //pre vsetky signaly, kde sa rovna meno a zaroven obsahuju hocaku z ovplyvnenych prvkov, posunie sa 
                                foreach (List<string> polozka3 in final)
                                {
                                    //polozka3[0] neobsahuje nazov signalu - ten si musim zistit
                                    if (universalList[final.IndexOf(polozka3)][4].Equals(signalposun[posunuty][0]))
                                    {
                                        //polozka3 obsahuje dany signal, ktory ideme upravit hodnotami z signalposun2[posunuty]
                                        for (int t = 0; t < polozka3.Count; t++)
                                        {
                                            if (signalposun[posunuty].Contains(polozka3[t]))
                                            {
                                                index = finalnovy[final.IndexOf(polozka3)][t].IndexOf(",");
                                                int zacx = Int32.Parse(finalnovy[final.IndexOf(polozka3)][t].Substring(0, index));
                                                int konx = Int32.Parse(finalnovy[final.IndexOf(polozka3)][t].Substring(index + 1));
                                                finalnovy[final.IndexOf(polozka3)].RemoveAt(t);
                                                string najdeny = signalposun[posunuty][signalposun[posunuty].IndexOf(polozka3[t])];
                                                index = najdeny.IndexOf(",");
                                                zac1 = Int32.Parse(najdeny.Substring(0, index));
                                                kon1 = Int32.Parse(najdeny.Substring(index + 1));


                                                if (prvarovnaka)
                                                {
                                                    finalnovy[final.IndexOf(polozka3)].Insert(t, (zac1 - (((ovplyvnene.Count / 2) - ss) * posun)) + "," + konx);
                                                }
                                                else
                                                {
                                                    finalnovy[final.IndexOf(polozka3)].Insert(t, zacx + "," + (kon1 - (((ovplyvnene.Count / 2) - ss) * posun)));
                                                }

                                            }
                                        }

                                    }
                                }
                            }
                            for (int ss = (ovplyvnene.Count / 2); ss < ovplyvnene.Count; ss++)
                            {
                                int posunuty = ovplyvnene[ss];
                                //pre vsetky signaly, kde sa rovna meno a zaroven obsahuju hocaku z ovplyvnenych prvkov, posunie sa 
                                foreach (List<string> polozka3 in final)
                                {
                                    if (universalList[final.IndexOf(polozka3)][4].Equals(signalposun[posunuty][0]))
                                    {
                                        //polozka3 obsahuje dany signal, ktory ideme upravit hodnotami z signalposun2[posunuty]
                                        for (int t = 0; t < polozka3.Count; t++)
                                        {
                                            if (signalposun[posunuty].Contains(polozka3[t]))
                                            {
                                                index = finalnovy[final.IndexOf(polozka3)][t].IndexOf(",");
                                                int zacx = Int32.Parse(finalnovy[final.IndexOf(polozka3)][t].Substring(0, index));
                                                int konx = Int32.Parse(finalnovy[final.IndexOf(polozka3)][t].Substring(index + 1));
                                                finalnovy[final.IndexOf(polozka3)].RemoveAt(t);
                                                string najdeny = signalposun[posunuty][signalposun[posunuty].IndexOf(polozka3[t])];
                                                index = najdeny.IndexOf(",");
                                                zac1 = Int32.Parse(najdeny.Substring(0, index));
                                                kon1 = Int32.Parse(najdeny.Substring(index + 1));
                                                if (prvarovnaka)
                                                {
                                                    finalnovy[final.IndexOf(polozka3)].Insert(t, (zac1 + ((ss - (ovplyvnene.Count / 2)) * posun)) + "," + konx);
                                                }
                                                else
                                                {
                                                    finalnovy[final.IndexOf(polozka3)].Insert(t, zacx + "," + (kon1 + ((ss - (ovplyvnene.Count / 2)) * posun)));
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                
                //ulozime finalne trasy na linii
                foreach (List<string> polozka in finalnovy)
                {
                    //finalnovy.Add(new List<string>());
                    while (final[finalnovy.IndexOf(polozka)].Count > 0)
                        final[finalnovy.IndexOf(polozka)].RemoveAt(0);
                    foreach (string polozka2 in polozka)
                    {
                        final[finalnovy.IndexOf(polozka)].Add(polozka2);
                    }
                }
                //teraz mozme dvojice ukladat do vyslednych prepojeni pre vizualizaciu
                List<int> spracovanesignaly = new List<int>();

                Boolean nornalny;
                List<Nodes> uzly = new List<Nodes>();
                int indexnode = -1;
                for (i = 0; i < universalList.Count; i++)
                {
                    List<int> spracovanepozicie = new List<int>();
                    a = universalList[i][0];
                    aport = universalList[i][1];
                    b = universalList[i][2];
                    bport = universalList[i][3];
                    absignal = Int32.Parse(universalList[i][4]);
                    nornalny = true;

                    if (!(spracovanesignaly.Contains(absignal)))
                    {
                        spracovanesignaly.Add(absignal);
                        foreach (List<String> polozka in universalList)
                        {
                            string tmpa = polozka[0];
                            string tmpaport = polozka[1];
                            string tmpb = polozka[2];
                            string tmpbport = polozka[3];
                            int tmpabsignal = Int32.Parse(polozka[4]);
                            if (tmpabsignal == absignal)
                            {
                                spracovanepozicie.Add(universalList.IndexOf(polozka));
                                if (!(tmpa.Equals(a)))
                                {
                                    nornalny = false;
                                }

                            }
                        }
                        //tu musime vsunut opravu suradnic
                        //1.krok - zmazeme rovne ciary
                        foreach (int pozicia in spracovanepozicie)
                        {
                            if (final[pozicia].Count > 2)//alespon 3 prvky
                            {
                                j = 0;
                                int prvya, prvyb, druhya, druhyb;
                                while ((j + 2) < final[pozicia].Count)
                                {
                                    index = final[pozicia][j].IndexOf(",");
                                    prvya = Int32.Parse(final[pozicia][j].Substring(0, index));
                                    prvyb = Int32.Parse(final[pozicia][j].Substring(index + 1));
                                    index = final[pozicia][j + 2].IndexOf(",");
                                    druhya = Int32.Parse(final[pozicia][j + 2].Substring(0, index));
                                    druhyb = Int32.Parse(final[pozicia][j + 2].Substring(index + 1));
                                    if ((prvya == druhya) || (prvyb == druhyb))
                                    {
                                        final[pozicia].RemoveAt(j + 1);
                                    }
                                    else
                                    {
                                        j++;
                                    }

                                }
                            }
                        }
                        //2.krok - doplnenie chybajucich
                        foreach (int pozicia in spracovanepozicie)
                        {
                            foreach (string polozka in final[pozicia])
                            {
                                foreach (int pozicia2 in spracovanepozicie)
                                {
                                    if (pozicia != pozicia2)
                                    {
                                        for (int f = 0; f < (final[pozicia2].Count - 1); f++)
                                        {
                                            int prvya, prvyb, druhya, druhyb, vkladanea, vkladaneb;
                                            index = final[pozicia2][f].IndexOf(",");
                                            prvya = Int32.Parse(final[pozicia2][f].Substring(0, index));
                                            prvyb = Int32.Parse(final[pozicia2][f].Substring(index + 1));
                                            index = final[pozicia2][f + 1].IndexOf(",");
                                            druhya = Int32.Parse(final[pozicia2][f + 1].Substring(0, index));
                                            druhyb = Int32.Parse(final[pozicia2][f + 1].Substring(index + 1));
                                            index = polozka.IndexOf(",");
                                            vkladanea = Int32.Parse(polozka.Substring(0, index));
                                            vkladaneb = Int32.Parse(polozka.Substring(index + 1));

                                            if ((prvya == druhya) && (prvya == vkladanea))
                                            {
                                                if ((vkladaneb > Math.Min(prvyb, druhyb)) && (vkladaneb < Math.Max(prvyb, druhyb)))
                                                {
                                                    final[pozicia2].Insert(f + 1, polozka);
                                                }
                                            }
                                            else if ((prvyb == druhyb) && (prvyb == vkladaneb))
                                            {
                                                if ((vkladanea > Math.Min(prvya, druhya)) && (vkladanea < Math.Max(prvya, druhya)))
                                                {
                                                    final[pozicia2].Insert(f + 1, polozka);
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }
                        if (nornalny)
                        {
                            //najdeme signal
                            foreach (Modules modul in list)
                            {
                                if (((modul.GetName().Equals(a)) || ((modul.GetName().Equals(list[nadradenyindex].GetName())) && ((a.Equals("A$module"))))))
                                {
                                    foreach (Ports port in modul.GetPortList())
                                    {
                                        if (port.GetName().Equals(aport))
                                        {
                                            List<string> visitednode = new List<string>();
                                            List<int> visitednodename = new List<int>();
                                            int zac, kon;
                                            index = final[spracovanepozicie[0]][0].IndexOf(",");
                                            zac = Int32.Parse(final[spracovanepozicie[0]][0].Substring(0, index));
                                            kon = Int32.Parse(final[spracovanepozicie[0]][0].Substring(index + 1));
                                            uzly.Add(new Nodes(zac, kon));
                                            uzly[uzly.Count - 1].SetPort(port);
                                            port.SetNode(uzly[uzly.Count - 1]);
                                            if (list.IndexOf(modul) != nadradenyindex)
                                            {
                                                foreach (Signals item in port.GetSignalList(true, modul.GetPath()))
                                                {
                                                    if (localSignalList.IndexOf(item) == absignal)
                                                    {
                                                        item.SetStartNode(uzly[++indexnode]);
                                                        //Console.Out.WriteLine("pridavam start uzol, port " + port.GetName() + " , signal " + port.GetSignal(0).GetName());
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                foreach (Signals item in port.GetSignalList(false, modul.GetPath()))
                                                {
                                                    if (localSignalList.IndexOf(item) == absignal)
                                                    {
                                                        item.SetStartNode(uzly[++indexnode]);
                                                        //Console.Out.WriteLine("pridavam start uzol, port " + port.GetName() + " , signal " + port.GetSignal(0).GetName());
                                                    }
                                                }
                                            }
                                            visitednode.Add(final[spracovanepozicie[0]][0]);
                                            visitednodename.Add(indexnode);
                                            foreach (int cislo in spracovanepozicie)
                                            {
                                                foreach (string polozka in final[cislo])
                                                {
                                                    if (!(final[cislo].IndexOf(polozka) == 0))
                                                    {
                                                        if (!(visitednode.Contains(polozka)))
                                                        {
                                                            index = polozka.IndexOf(",");
                                                            zac = Int32.Parse(polozka.Substring(0, index));
                                                            kon = Int32.Parse(polozka.Substring(index + 1));
                                                            //zistime predchodcu, kde sa nachadza
                                                            int indexer = final[cislo].IndexOf(polozka);
                                                            indexer--;
                                                            int endindex = visitednode.IndexOf(final[cislo][indexer]);
                                                            uzly.Add(new Nodes(zac, kon));
                                                            if (final[cislo].IndexOf(polozka) == (final[cislo].Count - 1))  //posledna polozka finalu
                                                            {
                                                                foreach(Modules mod in list)
                                                                {
                                                                    foreach(Ports por in mod.GetPortList())
                                                                    {
                                                                        if((universalList[cislo][2] == mod.GetName()) && (universalList[cislo][3] == por.GetName()))
                                                                        {
                                                                            uzly[uzly.Count - 1].SetPort(por);
                                                                            por.SetNode(uzly[uzly.Count - 1]);
                                                                        }
                                                                    }
                                                                }                                                                
                                                            }

                                                            uzly[visitednodename[endindex]].AddNextNode(uzly[++indexnode]);
                                                            visitednode.Add(polozka);
                                                            visitednodename.Add(indexnode);
                                                        }
                                                    }
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }
                        else        //opacny smer
                        {
                            //najdeme signal
                            foreach (Modules modul in list)
                            {
                                if (((modul.GetName().Equals(a)) || ((modul.GetName().Equals(list[nadradenyindex].GetName())) && ((a.Equals("A$module"))))))
                                {
                                    foreach (Ports port in modul.GetPortList())
                                    {
                                        if (port.GetName().Equals(aport))
                                        {
                                            List<string> visitednode = new List<string>();
                                            List<int> visitednodename = new List<int>();
                                            int zac, kon;
                                            index = final[spracovanepozicie[0]][final[spracovanepozicie[0]].Count - 1].IndexOf(",");
                                            zac = Int32.Parse(final[spracovanepozicie[0]][final[spracovanepozicie[0]].Count - 1].Substring(0, index));
                                            kon = Int32.Parse(final[spracovanepozicie[0]][final[spracovanepozicie[0]].Count - 1].Substring(index + 1));
                                            uzly.Add(new Nodes(zac, kon));
                                            uzly[uzly.Count - 1].SetPort(port);
                                            port.SetNode(uzly[uzly.Count - 1]);
                                            if (list.IndexOf(modul) != nadradenyindex)
                                            {
                                                foreach (Signals item in port.GetSignalList(true, modul.GetPath()))
                                                {
                                                    if (localSignalList.IndexOf(item) == absignal)
                                                    {
                                                        item.SetStartNode(uzly[++indexnode]);
                                                        //Console.Out.WriteLine("pridavam start uzol, port " + port.GetName() + " , signal " + port.GetSignal(0).GetName());
                                                    }
                                                }
                                            }
                                            else
                                            {
                                                foreach (Signals item in port.GetSignalList(false, modul.GetPath()))
                                                {
                                                    if (localSignalList.IndexOf(item) == absignal)
                                                    {
                                                        item.SetStartNode(uzly[++indexnode]);
                                                        //Console.Out.WriteLine("pridavam start uzol, port " + port.GetName() + " , signal " + port.GetSignal(0).GetName());
                                                    }
                                                }
                                            }
                                            visitednode.Add(final[spracovanepozicie[0]][final[spracovanepozicie[0]].Count - 1]);
                                            visitednodename.Add(indexnode);
                                            foreach (int cislo in spracovanepozicie)
                                            {
                                                for (j = (final[cislo].Count - 1); j >= 0; j--)
                                                {
                                                    if (j != (final[cislo].Count - 1))
                                                    {
                                                        if (!(visitednode.Contains(final[cislo][j])))
                                                        {
                                                            index = final[cislo][j].IndexOf(",");
                                                            zac = Int32.Parse(final[cislo][j].Substring(0, index));
                                                            kon = Int32.Parse(final[cislo][j].Substring(index + 1));
                                                            //zistime predchodcu, kde sa nachadza
                                                            int indexer = final[cislo].IndexOf(final[cislo][j]);
                                                            indexer++;
                                                            int endindex = visitednode.IndexOf(final[cislo][indexer]);
                                                            uzly.Add(new Nodes(zac, kon));
                                                            if (j == 0)  //posledna polozka finalu
                                                            {
                                                                foreach (Modules mod in list)
                                                                {
                                                                    foreach (Ports por in mod.GetPortList())
                                                                    {
                                                                        if ((universalList[cislo][2] == mod.GetName()) && (universalList[cislo][3] == por.GetName()))
                                                                        {
                                                                            uzly[uzly.Count - 1].SetPort(por);
                                                                            por.SetNode(uzly[uzly.Count - 1]);
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            uzly[visitednodename[endindex]].AddNextNode(uzly[++indexnode]);
                                                            visitednode.Add(final[cislo][j]);
                                                            visitednodename.Add(indexnode);
                                                        }
                                                    }
                                                }
                                            }

                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                //vypis finalu
                //foreach (List<string> polozka in final)
                //{
                //    Console.Out.Write(final.IndexOf(polozka) + ") ");
                //    foreach (string polozka2 in polozka)
                //    {
                //        Console.Out.Write(polozka2 + "  ");
                //    }
                //    Console.Out.WriteLine();
                //}
                //foreach (List<List<string>> polozka1 in path)
                //{
                //    int indexac = path.IndexOf(polozka1);
                //    //Console.Out.WriteLine("Spojenie " + unizoz[indexac]);


                //    foreach (List<string> polozka2 in polozka1)
                //    {
                //        foreach (string polozka3 in polozka2)
                //        {
                //            Console.Out.Write(polozka3 + "  ");

                //        }
                //        Console.Out.WriteLine();
                //    }
                //}

                if (parentmodule != null && nadradenyindex != -1)
                {
                    list.RemoveAt(nadradenyindex);
                }
            }
        }

        public Boolean IsInList(List<List<String>> stringList, List<String> stringItem)
        {
            foreach (List<String> item in stringList)
            {
                //return true if stringItem is equal with item
                if (item.SequenceEqual(stringItem))
                {
                    return true;
                }
            }
            return false;
        }

        public int IndexInList(List<List<String>> stringList, List<String> stringItem)
        {
            for (int i = 0; i < stringList.Count; i++)
            {
                if (stringList[i].SequenceEqual(stringItem))
                {
                    return i;
                }
            }
            return -1;
        }

        public String ParseList(List<String> stringItem, int index)
        {
            if (stringItem[index] != null)
            {
                return stringItem[index];
            }
            return null;
        }

        public List<String> CopyList(List<String> stringList)
        {
            List<String> tmp = new List<string>();
            foreach (String item in stringList)
            {
                tmp.Add(item);
            }
            return tmp;
        }

        public List<List<String>> CopyList(List<List<String>> stringList)
        {
            List<List<String>> tmp = new List<List<String>>();
            foreach (List<String> list in stringList)
            {
                tmp.Add(new List<string>());
                foreach (String item in list)
                {
                    tmp[tmp.Count - 1].Add(item);
                }
            }
            return tmp;

        }

        public List<List<String>> ClearList(List<List<String>> stringList)
        {
            foreach (List<String> item in stringList)
            {
                while (item.Count != 0)
                {
                    item.RemoveAt(0);
                }
            }
            while (stringList.Count != 0)
            {
                stringList.RemoveAt(0);
            }
            return stringList;
        }

        public List<List<int>> ClearList(List<List<int>> intList)
        {
            foreach (List<int> item in intList)
            {
                while (item.Count != 0)
                {
                    item.RemoveAt(0);
                }
            }
            while (intList.Count != 0)
            {
                intList.RemoveAt(0);
            }
            return intList;
        }

        public List<List<String>> ModuleListRemove(List<List<String>> stringList, String a, String b)
        {
            int cnt = -1;
            foreach (List<String> item in stringList)
            {
                if ((item[0] == a) && (item[1] == b))
                {
                    cnt = stringList.IndexOf(item);
                    while (item.Count != 0)
                        item.RemoveAt(0);
                    break;
                }

            }
            if (cnt != -1)
            {
                stringList.RemoveAt(cnt);
            }
            return stringList;
        }

        public List<List<String>> ModuleListRemoveAt(List<List<String>> stringList, int index)
        {
            while (stringList[index].Count != 0)
            {
                stringList[index].RemoveAt(0);
            }
            stringList.RemoveAt(index);
            return stringList;
        }

        public List<Signals> getActualSignalList(ref List<Modules> list)
        {
            //not working for signal visualization without setting position
            //if (localSignalList == null || localSignalList.Count == 0)
            //    return null;
            //return localSignalList;
            localSignalList = null;
            localSignalList = new List<Signals>();
            foreach (Modules module in list)
            {
                foreach (Ports port in module.GetPortList())
                {
                    if (port.GetSignalList(true, module.GetPath()) != null)
                        foreach (Signals item in port.GetSignalList(true, module.GetPath()))
                        {
                            if (!(localSignalList.Contains(item)))
                            {
                                localSignalList.Add(item);
                            }
                        }
                }
            }
            return localSignalList;
        }

        public void SetLimits(int horizontal, int vertical)
        {
            this.horizontalimit = horizontal;
            this.verticallimit = vertical;
        }

        public int[] GetLimits()
        {
            int[] arr1 = new int[2];
            arr1[0] = this.horizontalimit;
            arr1[1] = this.verticallimit;
            return arr1;
        }

        public Boolean IsPositionSet(ref List<Modules> list, ref Modules parentmodule)
        {
            Boolean isPositionsSet = true;
            foreach (Modules module in list)
            {
                if (module.GetPosX1() == 0 && module.GetPosY1() == 0)
                    isPositionsSet = false;
            }
            if (parentmodule != null)
            {
                if (parentmodule.GetPosX2() == 0 && parentmodule.GetPosY2() == 0)
                    isPositionsSet = false;
            }
            return isPositionsSet;
        }
    }
}
