﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VCDToXML
{
    public enum TimeScale { s, ms, us, ns, ps, fs };

    public class Time
    {
        private int _scalevalue;
        private TimeScale _scaleunit;
        private long _value;

        public String TimeScaleString
        {
            get { return _scalevalue + _scaleunit.ToString(); }
        }

        public TimeScale TimeScale
        {
            get { return _scaleunit; }
            set { _scaleunit = value; }
        }

        public Time(TimeScale ts,int v, String t)
        {
            _scaleunit = ts;
            _scalevalue = v;
            _value = System.Convert.ToInt32(t);
        }
        /// <mSummary>
        /// Vrati cas v us alebo nastavi cas podla zadanej hodnoty v us
        /// </mSummary>
        public long usValue
        {
            get
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        return _value * 1000000;
                    case TimeScale.ms:
                        return _value * 1000;
                    case TimeScale.us:
                        return _value;
                    case TimeScale.ns:
                        return _value / 1000;
                    case TimeScale.ps:
                        return _value / 1000000;
                    case TimeScale.fs:
                        return _value / 1000000000;
                    default:
                        return _value;
                }
            }
            set
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        _value = value / 1000000;
                        break;
                    case TimeScale.ms:
                        _value = value / 1000;
                        break;
                    case TimeScale.us:
                        _value = value;
                        break;
                    case TimeScale.ns:
                        _value = value * 1000;
                        break;
                    case TimeScale.ps:
                        _value = value * 1000000;
                        break;
                    case TimeScale.fs:
                        _value = value * 1000000000;
                        break;
                    default:
                        _value = value;
                        break;
                }
            }
        }

        /// <mSummary>
        /// Vrati cas v ms alebo nastavi cas podla zadanej hodnoty v ms
        /// </mSummary>
        public long msValue
        {
            get
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        return _value * 1000;
                    case TimeScale.ms:
                        return _value;
                    case TimeScale.us:
                        return _value / 1000;
                    case TimeScale.ns:
                        return _value / 1000000;
                    case TimeScale.ps:
                        return _value / 1000000000;
                    case TimeScale.fs:
                        return _value / 1000000000000;
                    default:
                        return _value;
                }
            }
            set
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        _value = value / 1000;
                        break;
                    case TimeScale.ms:
                        _value = value;
                        break;
                    case TimeScale.us:
                        _value = value * 1000;
                        break;
                    case TimeScale.ns:
                        _value = value * 1000000;
                        break;
                    case TimeScale.ps:
                        _value = value * 1000000000;
                        break;
                    case TimeScale.fs:
                        _value = value * 1000000000000;
                        break;
                    default:
                        _value = value;
                        break;
                }
            }
        }
        
        /// <mSummary>
        /// Vrati cas v s alebo nastavi cas podla zadanej hodnoty v s
        /// </mSummary>
        public long sValue
        {
            get
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        return _value;
                    case TimeScale.ms:
                        return _value / 1000;
                    case TimeScale.us:
                        return _value / 1000000;
                    case TimeScale.ns:
                        return _value / 1000000000;
                    case TimeScale.ps:
                        return _value / 1000000000000;
                    case TimeScale.fs:
                        return _value / 1000000000000000;
                    default:
                        return _value;
                }
            }
            set
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        _value = value;
                        break;
                    case TimeScale.ms:
                        _value = value * 1000;
                        break;
                    case TimeScale.us:
                        _value = value * 1000000;
                        break;
                    case TimeScale.ns:
                        _value = value * 1000000000;
                        break;
                    case TimeScale.ps:
                        _value = value * 1000000000000;
                        break;
                    case TimeScale.fs:
                        _value = value * 1000000000000000;
                        break;
                    default:
                        _value = value;
                        break;
                }
            }
        }
        
        /// <mSummary>
        /// Vrati cas v ns alebo nastavi cas podla zadanej hodnoty v ns
        /// </mSummary>
        public long nsValue
        {
            get
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        return _value * 1000000000;
                    case TimeScale.ms:
                        return _value * 1000000;
                    case TimeScale.us:
                        return _value * 1000;
                    case TimeScale.ns:
                        return _value;
                    case TimeScale.ps:
                        return _value / 1000;
                    case TimeScale.fs:
                        return _value / 1000000;
                    default:
                        return _value;
                }
            }
            set
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        _value = value / 1000000000;
                        break;
                    case TimeScale.ms:
                        _value = value / 1000000;
                        break;
                    case TimeScale.us:
                        _value = value / 1000;
                        break;
                    case TimeScale.ns:
                        _value = value;
                        break;
                    case TimeScale.ps:
                        _value = value * 1000;
                        break;
                    case TimeScale.fs:
                        _value = value * 1000000;
                        break;
                    default:
                        _value = value;
                        break;
                }
            }
        }
        
        /// <mSummary>
        /// Vrati cas v ps alebo nastavi cas podla zadanej hodnoty v ps
        /// </mSummary>
        public long psValue
        {
            get
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        return _value * 1000000000000;
                    case TimeScale.ms:
                        return _value * 1000000000;
                    case TimeScale.us:
                        return _value * 1000000;
                    case TimeScale.ns:
                        return _value * 1000;
                    case TimeScale.ps:
                        return _value;
                    case TimeScale.fs:
                        return _value / 1000;
                    default:
                        return _value;
                }
            }
            set
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        _value = value / 1000000000000;
                        break;
                    case TimeScale.ms:
                        _value = value / 1000000000;
                        break;
                    case TimeScale.us:
                        _value = value / 1000000;
                        break;
                    case TimeScale.ns:
                        _value = value / 1000;
                        break;
                    case TimeScale.ps:
                        _value = value;
                        break;
                    case TimeScale.fs:
                        _value = value * 1000;
                        break;
                    default:
                        _value = value;
                        break;
                }
            }
        }
        
        /// <mSummary>
        /// Vrati cas v fs alebo nastavi cas podla zadanej hodnoty v fs
        /// </mSummary>
        public long fsValue
        {
            get
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        return _value * 1000000000000000;
                    case TimeScale.ms:
                        return _value * 1000000000000;
                    case TimeScale.us:
                        return _value * 1000000000;
                    case TimeScale.ns:
                        return _value * 1000000;
                    case TimeScale.ps:
                        return _value * 1000;
                    case TimeScale.fs:
                        return _value;
                    default:
                        return _value;
                }
            }
            set
            {
                switch (_scaleunit)
                {
                    case TimeScale.s:
                        _value = value / 1000000000000000;
                        break;
                    case TimeScale.ms:
                        _value = value / 1000000000000;
                        break;
                    case TimeScale.us:
                        _value = value / 1000000000;
                        break;
                    case TimeScale.ns:
                        _value = value / 1000000;
                        break;
                    case TimeScale.ps:
                        _value = value / 1000;
                        break;
                    case TimeScale.fs:
                        _value = value;
                        break;
                    default:
                        _value = value;
                        break;
                }
            }
        }

        public String Value
        {
            get { return _value.ToString(); }
        }
    }
}
