﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Antlr.Runtime.Tree;

namespace Antlr.Vhdl
{
    public static class GrammarTreeToString
    {
        /// <summary>
        /// Vypise parsovany strom do stringu (zachova stromovu hierarchiu). Hlbku daj 0 (rekurzivu pomocnik).
        /// </summary>
        public static string TreeToString(int hlbka, Antlr.Runtime.Tree.CommonTree tree)
        {
            string medzera = "";
            string vysledok = "";
            for (int i = 0; i < hlbka; i++)
            {
                medzera += " ";
            }

            if (tree.ChildCount == 0)
            {
                return (medzera + tree.Text + "\n");
            }
            else
            {
                vysledok = medzera + tree.Token.Text + "\n";
                for (int i = 0; i < tree.ChildCount; i++)
                {
                    vysledok += TreeToString(hlbka + 1, (Antlr.Runtime.Tree.CommonTree)tree.GetChild(i));
                }
                return vysledok;
            }
        }

        /// <summary>
        /// Vypise iba povodny text, ktory je parsovany danym stromom.
        /// </summary>
        public static string ToMyString(this ITree tree)
        {
            if (tree.ChildCount == 0) return tree.Text;
            else
            {
                string pamat = "";
                for (int i = 0; i < tree.ChildCount; i++)
                {
                    pamat += ToMyString(tree.GetChild(i));
                }
                return pamat;
            }
        }
        #region DominoExtension
        //vypise povodny text, ale s medzerami
        public static string ToMyString2(this ITree tree)
        {
            if (tree.ChildCount == 0)
            {
               /* if (tree.Type == vamsCSharp3Parser.WHEN || tree.Type == vamsCSharp3Parser.ELSE || tree.Type == vamsCSharp3Parser.AFTER)
                    return " " + tree.Text + " ";
                else
                    return tree.Text;*/
                return tree.Text + " ";
            }
            else
            {
                string pamat = "";
                //if (tree.Type == vamsCSharp3Parser.T_range)
                //    pamat += "(";
               /* if (tree.Type == vamsCSharp3Parser.T_operator)
                    pamat += " ";*/
                if (tree.Type == vamsCSharp3Parser.T_name && tree.ChildCount == 4 && tree.GetChild(2).Type == vamsCSharp3Parser.T_term && tree.GetChild(1).Text == "(" && tree.GetChild(3).Text == ")")
                    pamat += ToMyString(tree) + " ";
                else
                    for (int i = 0; i < tree.ChildCount; i++)
                    {
                        /*if (tree.Type == vamsCSharp3Parser.T_range && tree.ChildCount == 3 && i == 1)
                            pamat += " ";*/
                        pamat += ToMyString2(tree.GetChild(i));
                        /* if (tree.Type == vamsCSharp3Parser.T_range && tree.ChildCount == 3 && i == 1)
                             pamat += " ";*/
                    }
                //if (tree.Type == vamsCSharp3Parser.T_range)
                //    pamat += ")";
                /*if (tree.Type == vamsCSharp3Parser.T_operator)
                    pamat += " ";*/
                return pamat;
            }
        }

        public static string ToMyString3(this ITree tree)
        {
            if (tree.ChildCount == 0)
                return tree.Text;
            else
            {
                string pamat = "";
                if (tree.Type == vamsCSharp3Parser.T_name)
                    pamat += tree.GetChild(0).Text + " ";
                else
                    for (int i = 0; i < tree.ChildCount; i++)
                        pamat += ToMyString3(tree.GetChild(i));
                return pamat;
            }
        }
        #endregion
    }
}
