using System;
using System.Collections.Generic;
using System.Text;
using Antlr.Vhdl;
using System.IO;

namespace VHDL2XML
{
    public abstract class BlockDeclaration
    {
        public string FullName
        {
            get {return VHDLToXML.DotConcateName(LibraryName,PackageName,Name);}
        }

        string _LibraryName = "";

        public string LibraryName
        {
            get { return _LibraryName; }
            set { _LibraryName = value; }
        }

        string _PackageName = "";

        public string PackageName
        {
            get { return _PackageName; }
            set { _PackageName = value; }
        }

        string _Name;

        public string Name
        {
            get { return _Name; }
            set
            {
                _Name = value.Trim();
                if (this is EntityDeclaration)
                {
                    _LibraryName = VHDLToXML.ParseName(ref _Name);
                }
                else if (this is ComponentDeclaration)
                {
                    _PackageName = VHDLToXML.ParseName(ref _Name);
                    _LibraryName = VHDLToXML.ParseName(ref _PackageName);
                }
            }
        }

        List<EntityPort> _ports = new List<EntityPort>();

        public List<EntityPort> Ports
        {
            get { return _ports; }
            set { _ports = value; }
        }

        int _LeftPortsCount = -1;

        public int LeftPortsCount
        {
            get { return _LeftPortsCount; }
            set { _LeftPortsCount = value; }
        }

        int _RightPortsCount = -1;

        public int RightPortsCount
        {
            get { return _RightPortsCount; }
            set { _RightPortsCount = value; }
        }
    }
}
