﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Text;

namespace VHDL2XML
{
    public class Simulation
    {
        public string GHDLSyntax(string file)
        {
            string arg,error,dir;

            dir = Environment.CurrentDirectory.ToString();
            dir = dir.Substring(0, dir.Length - 9);
            
            arg = "-a " + file;
            Process proc = new Process();
            ProcessStartInfo ghdl = new ProcessStartInfo(dir + "lib\\ghdl\\bin\\ghdl.exe");
            ghdl.Arguments = arg;
            ghdl.UseShellExecute = false;
            ghdl.CreateNoWindow = true;
            ghdl.RedirectStandardError = true;
            proc.StartInfo = ghdl;
            proc.Start();
            error = proc.StandardError.ReadToEnd();
            proc.WaitForExit();
            if (error.Length != 0)
                return error;
            else
                return "Syntax checked successfully.";
        }

        public string GHDLtoVCD(string file, string entity, int time)
        {
            string arg, error, dir;

            dir = Environment.CurrentDirectory.ToString();
            dir = dir.Substring(0, dir.Length - 9);

            string path = file.Substring(0, file.LastIndexOf('.')) + ".vcd";
            arg = "-c \"" + file + "\" -r " + entity + " --stop-time=" + time + "ns --vcd=\"" + path + "\"";
            Process proc = new Process();
            ProcessStartInfo ghdl = new ProcessStartInfo(dir + "lib\\ghdl\\bin\\ghdl.exe");
            ghdl.Arguments = arg;
            ghdl.UseShellExecute = false;
            ghdl.CreateNoWindow = true;
            ghdl.RedirectStandardError = true;
            proc.StartInfo = ghdl;
            proc.Start();
            error = proc.StandardError.ReadToEnd();
            proc.WaitForExit();

            if (File.Exists(path))
                return path;
            else
                return error;
        }
    }
}
