﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace VerilogToXML
{
    public class PortConnection
    {
        public PortConnection(Net n,PortInterface p)
        {
            Port = p;
            Net = n;
            NetBitList = new List<bool>(n.Range);
            PortBitList = new List<bool>(p.GetRange());
            for (int i = 0; i < n.Range; i++)
                NetBitList.Add(false);
            for (int i = 0; i < p.GetRange(); i++)
                PortBitList.Add(false);
            if (n.Range == p.GetRange())
                EqualRange = true;
        }

        public Net Net; // rodicovska siet net, v ktorej je toto spojenie vytvorene

        public PortInterface Port;

        public String GetModuleInstanceName()
            // vrati meno instancie modulu, ku ktoreho portu je pripojene toto spojenie,
            // v pripade, ze ide o definiciu modulu, vrati ""
        {
            return Port.GetModuleInstanceName();
        }

        public PortType GetPortType()
        {
            return Port.GetPortType();
        }
        public void SetPortType(PortType value)
        {
            Port.SetPortType(value);
        }

        public List<bool> NetBitList;
        public List<bool> PortBitList;
        public bool EqualRange = false;

        public String GetPortRangeName(int i)
        {
            if (Net.Range == 1)
                return "";
            if (NetBitList[i])
                return "(" + i + ")";
            else
                return "";
        }

        public bool IsRangeEqual(Net net, PortInstance portinstance) // true, ak portrange je rovnaky, ako netrange
        {
            if (net.Range == portinstance.GetRange())
                return true;
            else
                return false;
        }

        public int getNumOfBits()
        {
            int n = 0;

            foreach (bool b in NetBitList)
                if (b)
                    n++;

            return n;
        }


    }
}
