﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Antlr.Runtime;
using Antlr.Runtime.Tree;
using AntlrVerilogParser;

namespace VerilogToXML
{
    public class PrimitiveInstance : ModuleInstance
    {
        public PrimitiveInstance(String name, String type, Module parent)
        {
            InstanceName = name;
            Parent = parent;
            Module = new Module(type, 1, new CommonTree());
            PortInstanceList = new List<PortInstance>();

            Module.ModuleInstanceList = new List<ModuleInstance>();
            Module.NetList = new List<Net>();
        }

        PortType pt = PortType.output;

        int order = 0;
        public void ParsePortList(CommonTree tree, int index)
        {
            while (true)
            {

                ++index;
                if (tree.GetChild(index).Type == VerilogParser.RPAREN)
                    break;
                switch (tree.GetChild(index).Type)
                    {
                        case VerilogParser.EOF:
                            throw new Exception("---- ParsePortList ---- Unexpected end of file! ----"); // -*-
                        case VerilogParser.COMMA:
                            pt = PortType.input;
                            continue;
                        case VerilogParser.BNOT:
                            continue;
                        case VerilogParser.IDENTIFIER:
                        case VerilogParser.ESCAPED_IDENTIFIER:
                            PortInstance port = new PortInstance(this);
                            port.SetName(tree.GetChild(index).Text);
                            if (tree.GetChild(index + 1).Type == VerilogParser.LBRACK // hladam [x], ak najdem zmenim nazov portu
                                    && tree.GetChild(index + 2).Type == VerilogParser.NUMBER
                                    && tree.GetChild(index + 3).Type == VerilogParser.RBRACK)
                            {
                                port.SetName(tree.GetChild(index).Text + tree.GetChild(index+2).Text);
                            }
                            port.SetPortType(pt);
                            port.SetRange(0,0);
                            PortInstanceList.Add(port);
                            ParsePortConnection(tree, index, order++);
                            //Parent.NetList[0].Connections.Add(new PortConnection(Parent.NetList[0],port));
                            //Net net = FindNetInParent(tree.GetChild(index).Text, port);
                            if (tree.GetChild(index + 1).Type == VerilogParser.LBRACK // hladam [x], ak najdem preskocim
                                        && tree.GetChild(index + 2).Type == VerilogParser.NUMBER
                                        && tree.GetChild(index + 3).Type == VerilogParser.RBRACK)
                            {
                                index = index + 3;
                            }
                            break;
                        default:
                            throw new Exception("---- ParsePortList ---- Syntax error! ---- in '" + tree.GetChild(index).Text + "' ----" + this.InstanceName); // -*-
                    }
            }
        }
    }

}
