-- log clen XOR
entity Obvod_XOR is
  port (In1:in Bit; In2:in Bit; Out1:out Bit);
end Obvod_XOR;

-- telo architekt�ry XOR
architecture Spravanie_P of Obvod_XOR is
begin
  Out1 <= In1 xor In2;
end Spravanie_P;
---------------------------------------------
-- log clen OR
entity Obvod_OR is
  port (In1:in Bit; In2:in Bit; Out1:out Bit);
end Obvod_OR;

-- telo architekt�ry OR
architecture Spravanie_P of Obvod_OR is
begin
  Out1 <= In1 or In2;
end Spravanie_P;
---------------------------------------------
-- log clen AND
entity Obvod_AND is
  port (In1:in Bit; In2:in Bit; Out1:out Bit);
end Obvod_AND;

-- telo architekt�ry AND
architecture Spravanie_P of Obvod_AND is
begin
  Out1 <= In1 and In2;
end Spravanie_P;
---------------------------------------------
--neuplna jednobitova scitacka
entity Neuplna_scitacka is
    port (A:in Bit; B:in Bit; C:out Bit; S:out Bit);
end Neuplna_scitacka;

architecture Struktura of Neuplna_scitacka is
    component Obvod_XOR is
       port (In1:in Bit; In2:in Bit; Out1:out Bit);
    end component;
    component Obvod_AND is
       port (In1:in Bit; In2:in Bit; Out1:out Bit);
    end component;
begin
   OXOR:Obvod_XOR
      port map(In1=>A, In2=>B, Out1=>S);
   OAND:Obvod_AND
      port map(In1=>A, In2=>B, Out1=>C);
end Struktura;
---------------------------------------------
--uplna jednobitova scitacka
entity Uplna_scitacka is
    port (A:in Bit; B:in Bit; Ci:in Bit; Co:out Bit; S:out Bit);
end Uplna_scitacka;

architecture Struktura of Uplna_scitacka is
    signal S1,C1,C2: Bit;
    component Neuplna_scitacka is
       port (A:in Bit; B:in Bit; C:out Bit; S:out Bit);
    end component; 
    component Obvod_OR is
       port (In1:in Bit; In2:in Bit; Out1:out Bit);
    end component;
begin
    NS1:Neuplna_scitacka
       port map(A=>A, B=>B, C=>C1, S=>S1);
    NS2:Neuplna_scitacka
       port map(A=>S1, B=>Ci, C=>C2, S=>S);
    OR1:Obvod_OR
       port map(In1=>C1, In2=>C2, Out1=>Co);
end Struktura;
---------------------------------------------
--stvorbitova scitacka
entity Scitacka4bit is
    port(A1:in Bit; A2:in Bit; A3:in Bit; A4:in Bit; B1:in Bit; B2:in Bit; B3:in Bit; B4:in Bit; C:in Bit; S1:out Bit; S2:out Bit; S3:out Bit; S4:out Bit; S5:out Bit);
end Scitacka4bit;

architecture Struktura of Scitacka4bit is
    signal C1,C2,C3: Bit;
    component Uplna_scitacka is
       port (A:in Bit; B:in Bit; Ci:in Bit; Co:out Bit; S:out Bit);
    end component;
begin
   US1:Uplna_scitacka
      port map(A=>A1, B=>B1, Ci=>C, Co=>C1, S=>S1);
   US2:Uplna_scitacka
      port map(A=>A2, B=>B2, Ci=>C1, Co=>C2, S=>S2);       
   US3:Uplna_scitacka
      port map(A=>A3, B=>B3, Ci=>C2, Co=>C3, S=>S3);       
   US4:Uplna_scitacka
      port map(A=>A4, B=>B4, Ci=>C3, Co=>S5, S=>S4);
end Struktura;

architecture Spravanie of Scitacka4bit is
    signal C1,C2,C3: Bit;
begin
    S1 <= ((A1 xor B1) xor C);
    C1 <= ((A1 and B1) or ((A1 xor B1) and C));
    S2 <= ((A2 xor B2) xor C1);
    C2 <= ((A2 and B2) or ((A2 xor B2) and C1));
    S3 <= ((A3 xor B3) xor C2);
    C3 <= ((A3 and B3) or ((A3 xor B3) and C2));
    S4 <= ((A4 xor B4) xor C3);
    S5 <= ((A4 and B4) or ((A4 xor B4) and C3));
end Spravanie;
---------------------------------------------
--testovacia entita
entity TESTBNCH is
end TESTBNCH;

architecture stimulus of TESTBNCH is
    component Scitacka4bit is
       port(A1:in Bit; A2:in Bit; A3:in Bit; A4:in Bit; B1:in Bit; B2:in Bit; B3:in Bit; B4:in Bit; C:in Bit; S1:out Bit; S2:out Bit; S3:out Bit; S4:out Bit; S5:out Bit);
    end component;
    for S4b_st: Scitacka4bit use entity work.Scitacka4bit(Struktura);
    for S4b_sp: Scitacka4bit use entity work.Scitacka4bit(Spravanie);
--
    signal   A1, A2, A3, A4, B1, B2, B3, B4, C, S1, S2, S3, S4, S5, S_1, S_2, S_3, S_4, S_5, K : Bit :='0';
begin
    S4b_st: Scitacka4bit port map (A1 => A1, A2 => A2, A3 => A3, A4 => A4, B1 => B1, B2 => B2, B3 => B3, B4 => B4, C => C, S1 => S1, S2 => S2, S3 => S3, S4 => S4, S5 => S5);
    S4b_sp: Scitacka4bit port map (A1 => A1, A2 => A2, A3 => A3, A4 => A4, B1 => B1, B2 => B2, B3 => B3, B4 => B4, C => C, S1 => S_1, S2 => S_2, S3 => S_3, S4 => S_4, S5 => S_5);
--komparator
    K <= (not(S1 xor S_1) and not(S2 xor S_2) and not(S3 xor S_3) and not(S4 xor S_4) and not(S5 xor S_5));
--generator vstupov
    STIMULUS1:	A1 <= '1' after 2 ns, '0' after 18 ns, '1' after 36 ns, '0' after 52 ns;
    STIMULUS2:	A2 <= '1' after 6 ns, '0' after 22 ns, '1' after 40 ns, '0' after 56 ns;
    STIMULUS3:	A3 <= '1' after 10 ns, '0' after 26 ns, '1' after 44 ns, '0' after 60 ns;
    STIMULUS4:	A4 <= '1' after 14 ns, '0' after 30 ns, '1' after 48 ns, '0' after 64 ns;
    STIMULUS5:	B1 <= '1' after 4 ns, '0' after 20 ns, '1' after 38 ns, '0' after 54 ns;
    STIMULUS6:	B2 <= '1' after 8 ns, '0' after 24 ns, '1' after 42 ns, '0' after 58 ns;
    STIMULUS7:	B3 <= '1' after 12 ns, '0' after 28 ns, '1' after 46 ns, '0' after 62 ns;
    STIMULUS8:	B4 <= '1' after 16 ns, '0' after 32 ns, '1' after 50 ns, '0' after 66 ns;
    STIMULUS9:	C <= '1' after 34 ns;
end stimulus;