entity JK_PO is
    port (J,K,CLK,R: in Bit;Q,Qn: out Bit);
end JK_PO;

architecture Spravanie of JK_PO is
   signal P:Bit;
begin
	B : block is
	begin 
 	P <=   '0' after 7 ns when R='0' else
 	       P after 3 ns when (J='0' and K='0') and (CLK='1' and not CLK'stable) else
 			 '1' after 3 ns when (J='1'and K='0') and (CLK='1' and not CLK'stable) else
			 '0' after 3 ns when (J='0'and K='1') and (CLK='1' and not CLK'stable) else
			 not P after 3 ns when (J='1'and K='1') and (CLK='1' and not CLK'stable);		
	end block B;
	Q <= P;
	Qn <= not P;
end Spravanie;
-------------------------------------------------------------
entity O_XOR is
    port (A:in Bit_vector(1 downto 0); C:out Bit);
end O_XOR;

architecture Spravanie of O_XOR is
begin
    C <= A(1) xor A(0);
end Spravanie;
---------------------------------------------
entity O_NOT is
    port (A:in Bit; C:out Bit);
end O_NOT;

architecture Spravanie of O_NOT is
begin
    C <= not A;
end Spravanie;
---------------------------------------------
entity O_AND is
    port (A:in Bit_vector(1 downto 0); C:out Bit);
end O_AND;

architecture Spravanie of O_AND is
begin
    C <= A(1) and A(0);
end Spravanie;
---------------------------------------------
entity O_4AND is
    port (A:in Bit_vector(3 downto 0); C:out Bit);
end O_4AND;

architecture Spravanie of O_4AND is
begin
    C <= (A(3) and A(2)) and (A(1) and A(0));
end Spravanie;
---------------------------------------------
entity O_5AND is
    port (A:in Bit_vector(4 downto 0); C:out Bit);
end O_5AND;

architecture Spravanie of O_5AND is
begin
    C <= A(4) and ((A(3) and A(2)) and (A(1) and A(0)));
end Spravanie;
---------------------------------------------
entity DetekciaC is
    port (R:in Bit; A:in Bit_vector(3 downto 0); C:out Bit);
end DetekciaC;

architecture Spravanie of DetekciaC is
begin
       C <= '1' when A="0000" and A'Last_Value="1111" and not A'Stable and R='1';
end Spravanie;
-------------------------------------------------------------
entity Pocitadlo is
    port (Resetn, Enable, Clk : in Bit; O : inout Bit_vector(3 downto 0); Carry : out Bit);
end Pocitadlo;

architecture Struktura of Pocitadlo is
    component O_XOR is
       port (A:in Bit_vector(1 downto 0); C:out Bit);
    end component;
    component O_NOT is
       port (A:in Bit; C:out Bit);
    end component;
    component O_AND is
       port (A:in Bit_vector(1 downto 0); C:out Bit);
    end component;
    component O_4AND is
       port (A:in Bit_vector(3 downto 0); C:out Bit);
    end component;
    component O_5AND is
       port (A:in Bit_vector(4 downto 0); C:out Bit);
    end component;
    component JK_PO is
        port (J,K,CLK,R: in Bit;Q,Qn: out Bit);
    end component;
    component DetekciaC is
        port (R:in Bit; A:in Bit_vector(3 downto 0); C:out Bit);
    end component;
    signal J1,K1,J2,K2,J3,K3,J4,K4,Z1,Z2,Z3,Z4,Z1n,Z2n,Z3n,Z4n,nO2,nO0 : Bit;
begin
JK1: JK_PO
    port map (J1,K1,Clk,Resetn,Z1,Z1n);
JK2: JK_PO
    port map (J2,K2,Clk,Resetn,Z2,Z2n);
JK3: JK_PO
    port map (J3,K3,Clk,Resetn,Z3,Z3n);
JK4: JK_PO
    port map (J4,K4,Clk,Resetn,Z4,Z4n);
AND1: O_4AND
    port map (A(3) => Z2n,A(2) => Z3n,A(1) => Z4,A(0) => Enable,C => J1);
AND2: O_4AND
    port map (A(3) => Z2n,A(2) => Z3,A(1) => Z4,A(0) => Enable,C => K1);
AND3: O_AND
    port map (A(1) => Z4n,A(0) => Enable,C => J2);
AND4: O_AND
    port map (A(1) => Z4,A(0) => Enable,C => K2);
AND5: O_4AND
    port map (A(3) => Z1,A(2) => Z2n,A(1) => Z4,A(0) => Enable,C => J3);
AND6: O_4AND
    port map (A(3) => Z1n,A(2) => Z2n,A(1) => Z4,A(0) => Enable,C => K3);
AND7: O_AND
    port map (A(1) => Z2,A(0) => Enable,C => J4);
AND8: O_AND
    port map (A(1) => Z2n,A(0) => Enable,C => K4);
XOR1: O_XOR
    port map (A(1) => Z1,A(0) => Z3,C => O(2));
XOR2: O_XOR
    port map (A(1) => Z2,A(0) => Z4,C => O(0));
O(3) <= Z3;
O(1) <= Z4;

AND9: O_4AND
   port map(A(3) => O(3),A(2) => O(2),A(1) => O(1),A(0) => O(0),C => Carry);
--DC: DetekciaC
  --  port map (Resetn,O,Carry);
end Struktura;

architecture Spravanie of Pocitadlo is
    signal counter:Integer:=0;
begin
B: Block is
	begin
	counter <=  0 after 7 ns when Resetn='0' else
	            (counter + 1) after 3 ns when Enable='1' and counter<15 and (not CLK'stable and CLK='1')else
				   0 after 3 ns when Enable='1' and counter>=15 and (not CLK'stable and CLK='1');
   end block B;
   O <= "0001" when counter=1 else
         "0010" when counter=2 else
         "0011" when counter=3 else
         "0100" when counter=4 else
         "0101" when counter=5 else
         "0110" when counter=6 else
         "0111" when counter=7 else
         "1000" when counter=8 else
         "1001" when counter=9 else
         "1010" when counter=10 else
         "1011" when counter=11 else
         "1100" when counter=12 else
         "1101" when counter=13 else
         "1110" when counter=14 else
         "1111" when counter=15 else
         "0000" when counter=0;
--    Carry <= '1' when O="0000" and O'Last_Value="1111" and not O'Stable and Resetn='1';
    Carry <= '1' when O="1111" else '0';
end Spravanie;
-------------------------------------------------------------
entity Test is
end Test;

architecture Testovanie of Test is
    component Pocitadlo is
        port (Resetn, Enable, Clk : in Bit; O : inout Bit_vector(3 downto 0); Carry : out Bit);
    end component;
    signal R,E,C,Carry,Carry2 : Bit;
    signal O,O2 : Bit_vector(3 downto 0);
    for POC_Struktura: Pocitadlo use entity work.Pocitadlo(Struktura);
    for POC_Spravanie: Pocitadlo use entity work.Pocitadlo(Spravanie);
begin
POC_Struktura: Pocitadlo
    port map (R,E,C,O,Carry);
POC_Spravanie: Pocitadlo
    port map (R,E,C,O2,Carry2);
    R <= '1', '0' after 165 ns, '1' after 175 ns, '0' after 403 ns, '1' after 427 ns;
    E <= '1', '0' after 14 ns, '1' after 16 ns;
--    E <= '1', '0' after 50 ns, '1' after 70 ns;
    process
    begin
		c <= '0';
		wait for 5 ns;
		c <= '1';
		wait for 5 ns;
    end process;
end Testovanie;