entity negacia is
 port (i1: in Bit; oneg: out Bit);
end negacia;

entity and2 is
 port (i1,i2: in Bit; oa2: out Bit);
end and2;

entity and3 is
port (i1,i2,i3: in Bit; oa3: out Bit);
end and3;

entity or2 is
port (i1,i2: in Bit; oo2: out Bit);
end or2;

entity or3 is
port (i1,i2,i3: in Bit; oo3: out Bit);
end or3;

architecture spravanie_negacia of negacia is
begin
oneg <= not i1;
end spravanie_negacia;

architecture spravanie_and2 of and2 is
begin
oa2 <= i1 and i2;
end spravanie_and2;

architecture spravanie_and3 of and3 is
begin
oa3 <= i1 and i2 and i3;
end spravanie_and3;

architecture spravanie_or2 of or2 is
begin
oo2 <= i1 or i2;
end spravanie_or2;

architecture spravanie_or3 of or3 is
begin
oo3 <= i1 or i2 or i3;
end spravanie_or3;

entity dpo is
port (dpo_in: in BIT; 
reset: in BIT;
 clock: in BIT;
 dpo_out: out BIT;
 dpo_out_neg: out BIT
);
end dpo;

architecture spravanie_dpo of dpo is
begin
p:process(clock, reset)
begin
if reset='0' then
dpo_out<='0' after 6 ns;
dpo_out_neg <= '1' after 6 ns;
elsif (clock='0' and clock'event) then
dpo_out <= dpo_in after 3 ns;
dpo_out_neg <= not dpo_in after 3 ns;
end if;
end process;
end spravanie_dpo;

entity obvod_vstupy is
port (
z1,z2,z3,z4,z1neg,z2neg,z3neg,z4neg: in BIT;
 ModStick: in BIT; D1_4: out BIT;
 D2_4: out BIT;
 D3_4: out BIT;
 D4_3: out BIT);
end obvod_vstupy;

architecture struktura_vstupy of obvod_vstupy is
component negacia
port (i1: in BIT;oneg: out BIT);
end component ;

component and2
port (i1,i2: in BIT; oa2: out BIT);
end component ;

component and3
port (i1,i2,i3: in BIT; oa3: out BIT);
end component ;

component or2
port (i1,i2: in BIT; oo2: out BIT);
end component ;

component or3
port (i1,i2,i3: in BIT; oo3: out BIT);
end component ;

signal d1_1, d1_2, d1_3, d2_1, d2_2, d2_3: Bit;
signal d3_1, d3_2, d3_3, d4_1, d4_2, MSneg : Bit;

begin
--negacie
N1:negacia port map (ModStick, MSneg);
--D1
D11:and2 port map (MSneg, z1, d1_1);
D12:and2 port map (z4neg, z1, d1_2);
D13:and3 port map (z2, z3, z4, d1_3);
D14:or3 port map (d1_1, d1_2, d1_3, D1_4);
--D2
D21:and2 port map (z2, z4neg, d2_1);
D22:and3 port map (z4, z2, z3neg, d2_2);
D23:and3 port map (z3, z4, z2neg, d2_3);
D24:or3 port map (d2_1, d2_2, d2_3, D2_4);
--D3
D31:and2 port map (z3, z4neg, d3_1);
D32:and3 port map (z1neg, z4, z3neg, d3_2);
D33:and3 port map (z3neg, z4, MSneg, d3_3);
D34:or3 port map (d3_1, d3_2, d3_3, D3_4);	
--D4
D41:and2 port map (z3neg, z4neg, d4_1);
D42:and2 port map (z1neg, z4neg, d4_2);
D43:or2 port map (d4_1, d4_2, D4_3);
end struktura_vstupy;

entity pocitadlo is
port (
Reset: in BIT; ModStick: in BIT; CLK: in BIT; Pocitadlo: out BIT_VECTOR (3 downto 0); Sticked: out BIT);
end pocitadlo;

architecture struktura_pocitadlo of pocitadlo is
component dpo
port (dpo_in, reset, clock: in BIT; dpo_out, dpo_out_neg: out BIT);
end component;

component obvod_vstupy
port (z1,z2,z3,z4,z1neg,z2neg,z3neg,z4neg,ModStick: in BIT;
 D1_4,D2_4,D3_4,D4_3: out BIT);
end component;

component negacia
port (i1: in Bit; oneg: out Bit);
end component;

component and2
port (i1,i2: in Bit; oa2: out Bit);
end component;

component or2
port (i1,i2: in Bit; oo2: out Bit);
end component;

signal oD1,oD2,oD3,oD4,D1_4,D2_4,D3_4,D4_3,oD1neg: BIT;
signal oD2neg,oD3neg,oD4neg,pom1,pom2,pom3,pom4:BIT;
begin
--obvod_vstupy
stage1:obvod_vstupy port map(oD1,oD2,oD3,oD4,oD1neg,oD2neg,oD3neg,oD4neg,ModStick,D1_4,D2_4,D3_4,D4_3);
--D preklapacie obvody
Z1:dpo port map(D1_4,reset,CLK,oD1,oD1neg);
Z2:dpo port map(D2_4,reset,CLK,oD2,oD2neg);
Z3:dpo port map(D3_4,reset,CLK,oD3,oD3neg);
Z4:dpo port map(D4_3,reset,CLK,oD4,oD4neg);
P2:and2 port map(oD3,oD1neg,pom1);
P3:and2 port map(oD1,oD3,pom2);
P4:or2 port map (oD4,pom2,pom3);
P5:and2 port map (oD1,oD3,pom4);
vystup:
Pocitadlo(0)<=pom3;
Pocitadlo(1)<=pom1;
Pocitadlo(2)<=oD2;
Pocitadlo(3)<=oD1;
Sticked<=pom4;
end struktura_pocitadlo;

architecture spravanie_pocitadlo of pocitadlo is
constant Delaysynch:Time:=3 ns;
constant Delayasynch:Time:=6 ns;

signal pom:BIT_VECTOR(3 downto 0);
begin
process(CLK, Reset)
begin
if Reset='0' then
pom<="0000" after Delayasynch;
Sticked<='0' after Delayasynch;
elsif (CLK='0' and CLK'event) then
case pom is
when "0000" => pom<="0001" after Delaysynch; Sticked<='0' after Delaysynch;
when "0001" => pom<="0010" after Delaysynch; Sticked<='0' after Delaysynch;
when "0010" => pom<="0011" after Delaysynch; Sticked<='0' after Delaysynch;
when "0011" =>
 pom<="0100" after Delaysynch; Sticked<='0' after Delaysynch;
when "0100" => pom<="0101" after Delaysynch; Sticked<='0' after Delaysynch;
when "0101" => pom<="0110" after Delaysynch; Sticked<='0' after Delaysynch;
when "0110" => pom<="0111" after Delaysynch; Sticked<='0' after Delaysynch;
when "0111" => pom<="1000" after Delaysynch; Sticked<='0' after Delaysynch;
when "1000" =>
 pom<="1001" after Delaysynch; Sticked<='0' after Delaysynch;
when "1001" =>
if ModStick='0' then
pom<="1001" after Delaysynch; Sticked<='1' after Delaysynch;
elsif ModStick='1' then
pom<="0000" after Delaysynch; Sticked<='0' after Delaysynch;
end if;
when others => pom<="0000" after Delaysynch; Sticked<='0' after Delaysynch;
end case;
end if;
end process;
Pocitadlo<=pom;
end spravanie_pocitadlo;

entity testbench is
end testbench;

architecture stimulus_pocitadlo of testbench is
component pocitadlo is
port (Reset: in BIT; ModStick: in BIT; CLK: in BIT; Pocitadlo: out BIT_VECTOR (3 downto 0);
         Sticked: out BIT);
end component;

for DUT1:pocitadlo use entity Work.pocitadlo(struktura_pocitadlo);
for DUT2:pocitadlo use entity Work.pocitadlo(spravanie_pocitadlo); 

signal Reset,ModStick,CLK,Sticked_str,Sticked_spr : bit;
signal Struktura: Bit_vector(3 downto 0);
signal Spravanie: Bit_vector(3 downto 0);

begin
p:process(CLK)
begin

if CLK='0' then CLK<='1' after 20 ns;
elsif CLK='1' then
 CLK<='0' after 10 ns;
end if;
end process;

DUT1:pocitadlo port map (Reset,ModStick,CLK,Struktura(3 downto 0),Sticked_str);
DUT2:pocitadlo port map (Reset,ModStick,CLK,Spravanie(3 downto 0),Sticked_spr);

STIMULUS1: Reset <= '0' after 0 ns, '1' after 30 ns, '0' after 400 ns, '1' after 500 ns;
STIMULUS2: ModStick <= '0' after 0 ns, '1' after 650 ns;
end stimulus_pocitadlo;