module NAND3 (IN1, IN2, IN3, OUT);
	input IN1,IN2,IN3;
	output OUT;
	assign OUT = ~(IN1 & IN2 & IN3);
endmodule

module NAND4 (IN1, IN2, IN3, IN4, OUT);
	input IN1,IN2,IN3,IN4;
	output OUT;
	assign OUT = ~(IN1 & IN2 & IN3 & IN4);
endmodule

module NAND2 (IN1, IN2, OUT);
	input IN1,IN2;
	output OUT;
	assign OUT = ~(IN1 & IN2);
endmodule

module NOT (IN, OUT);
	input IN;
	output OUT;
	assign OUT = ~ IN;
endmodule

module SUM (IN1, IN2, CI, OUT, CO);
	input IN1,IN2,CI;
	output OUT,CO;
	wire in1in2,in1ci,in2ci;
	NAND2 nand2a(IN1, IN2, in1in2);
	NAND2 nand2b(IN1, CI, in1ci);
	NAND2 nand2c(IN2, CI, in2ci);
	NAND3 nand3a(in1in2, in1ci, in2ci, CO);

	wire notin1,notin2,notci;

	wire in1notin2notci,notin1in2notci,notin1notin2ci,in1in2ci;

	NOT nota(IN1,notin1);
	NOT notb(IN2,notin2);
	NOT notc(CI,notci);
	NAND3 nand3b(IN1,notin2,notci,in1notin2notci);
	NAND3 nand3c(notin1,IN2,notci,notin1in2notci);
	NAND3 nand3d(notin1,notin2,CI,notin1notin2ci);
	NAND3 nand3e(IN1,IN2,CI,in1in2ci);

	NAND4 nand4a(in1notin2notci,notin1in2notci,notin1notin2ci,in1in2ci,OUT);
	
endmodule


module SUM8bit (IN1, IN2, OUT, CO);
	output [7:0] OUT;
	output CO;
	input [7:0] IN1;
	input [7:0] IN2;
	wire [6:0] carrysignal;

	SUM sum0(IN1[0],IN2[0], 0,OUT[0],carrysignal[0]);
	SUM sum1(IN1[1],IN2[1],carrysignal[0],OUT[1],carrysignal[1]);
	SUM sum2(IN1[2],IN2[2],carrysignal[1],OUT[2],carrysignal[2]);
	SUM sum3(IN1[3],IN2[3],carrysignal[2],OUT[3],carrysignal[3]);
	SUM sum4(IN1[4],IN2[4],carrysignal[3],OUT[4],carrysignal[4]);
	SUM sum5(IN1[5],IN2[5],carrysignal[4],OUT[5],carrysignal[5]);
	SUM sum6(IN1[6],IN2[6],carrysignal[5],OUT[6],carrysignal[6]);
	SUM sum7(IN1[7],IN2[7],carrysignal[6],OUT[7],CO);

endmodule



