﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using VHDL2XML;

namespace HDLVisualizer
{
    public partial class frmsimtime : Form
    {
        string type;
        string path;
        private Project project;
        string file;

        public frmsimtime(string t, ref Project pr, string f)
        {
            project = pr;
            file = f;

            InitializeComponent();
            type = t;
            if (type == "verilog")
            {
                label4.Visible = false;
                label6.Visible = false; 
                internal_name.Visible = false;
            }
        }

        private void button_Click(object sender, EventArgs e)
        {
            if (time.Text == "")
            {
                MessageBox.Show("Set simulaton stop time");
            }
            else
            {
                string output = null, input, inputentity, pom;
                int help;
                List<string> temp = new List<string>();
                StreamReader reader = new StreamReader(file);

                input = time.Text.ToString();
                inputentity = internal_name.Text;
                help = int.Parse(input);
                this.Close();

                if (type == "vhdl")
                {
                    VHDL2XML.Simulation vhdlsimul = new VHDL2XML.Simulation();
                    if (inter.Checked)
                        output = vhdlsimul.GHDLtoVCD(file, inputentity, help);
                    if (exter.Checked)
                    {
                        while (reader.Peek() >= 0)
                            temp.Add(reader.ReadLine());
                        temp.Add("");
                        reader = new StreamReader(path);
                        while (reader.Peek() >= 0)
                            temp.Add(reader.ReadLine());
                        pom = System.IO.Path.GetDirectoryName(file) + "\\" + System.IO.Path.GetFileNameWithoutExtension(file) + "_temp.vhdl";
                        System.IO.File.WriteAllLines(pom, temp);
                        output = vhdlsimul.GHDLtoVCD(pom, "testbench", help);
                        System.IO.File.Delete(pom);
                    }
                }
                else if (type == "verilog")
                {
                    VerilogToXML.Verilog2XML verilog2xml = new VerilogToXML.Verilog2XML(file);
                    if (inter.Checked)
                    {
                        output = verilog2xml.VerilogToVCD(file, "", help);
                    }
                    else if (exter.Checked)
                    {
                        output = verilog2xml.VerilogToVCD(file, path, help);
                    }
                }

                //add file to project or show error
                if (output.LastIndexOf(".vcd") != -1)
                {
                    project.addVCD(output);
                }
                else
                    MessageBox.Show("REPORT:\n" + output);

                DialogResult = System.Windows.Forms.DialogResult.OK;
            }
        }

        private void inter_CheckedChanged(object sender, EventArgs e)
        {
            brow.Enabled = false;
            external_path.Enabled = false;
            label5.Enabled = false;
            internal_name.Enabled = true;
            label6.Enabled = true;
            label4.Enabled = true;
        }

        private void exter_CheckedChanged(object sender, EventArgs e)
        {
            brow.Enabled = true;
            external_path.Enabled = true;
            label5.Enabled = true;
            internal_name.Enabled = false;
            label6.Enabled = false;
            label4.Enabled = false;
        }

        private void brow_Click(object sender, EventArgs e)
        {
            OpenFileDialog open = new OpenFileDialog();
            if (type == "vhdl")
            {
                open.Filter = "VHDL source files (*.vhd,*.vhdl)|*.vhd;*.vhdl";
                open.Title = "Select a VHDL source file";
            }
            if (type == "verilog")
            {
                open.Filter = "VHDL source files (*.v)|*.v";
                open.Title = "Select a Verilog source file";
            }

            if (open.ShowDialog() == DialogResult.OK)
            {
                external_path.Text = open.FileName;
                path = external_path.Text;
            }
        }

        string old_value = "";
        private void time_TextChanged(object sender, EventArgs e)
        {

            TextBox tb = (TextBox)sender;
            string text = tb.Text;
            int time;

            if (Int32.TryParse(tb.Text, out time) || tb.Text == "")
            {
                old_value = tb.Text;
            }
            else
                tb.Text = old_value;
        }
    }
}
